import java.io.*;
import java.net.*;
import java.awt.*;
import java.awt.im.*;
import java.awt.image.*;
import java.awt.event.*;
import java.awt.geom.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;
import java.util.*;
import static java.awt.RenderingHints.*;


public class AreaDialog extends JDialog implements ActionListener, DocumentListener, Basis
{

public static final int MAX_LOG			= 35;

public static final int SELECT_OK		= 1;
public static final int SELECT_CANCEL	= 2;
public static final int SELECT_CLOSE	= 3;

private JTextArea t;
private JButton ok, ca;
private JRadioButton all, lobby, field;

private int select;
private String data;
private String name;


public AreaDialog(JFrame f, Font font, int val)
{
	super(f, "Area", true);

	select = SELECT_CLOSE;
	data = "";

	setResizable(false);

	int y = 0;
	if(val == SERVER)	y = 30;

	int w = 400;
	int h = 405+y;
	Panel p = new Panel();
	p.setPreferredSize(new Dimension(w, h));
	p.setLayout(null);

	if(val == SERVER){
		ButtonGroup group = new ButtonGroup();
		all = new JRadioButton("ALL");
		lobby = new JRadioButton("LOBBY");
		field = new JRadioButton("FIELD");
		group.add(all);
		group.add(lobby);
		group.add(field);
		all.addActionListener(this);
		lobby.addActionListener(this);
		field.addActionListener(this);
		lobby.setSelected(true);
		all.setBounds(10, 10, 100, 20);
		lobby.setBounds(110, 10, 100, 20);
		field.setBounds(220, 10, 100, 20);
		p.add(all);
		p.add(lobby);
		p.add(field);
	}


	t = new JTextArea();
	t.setFont(font);
	t.setTabSize(4);
	JScrollPane a = new JScrollPane(t);
	a.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED);
	a.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
	t.getDocument().addDocumentListener(this);

	ok = new JButton("OK");
	ca = new JButton("CANCEL");


	a.setBounds(10, 10+y, 380, 350);
	ok.setBounds(90, 370+y, 100, 25);
	ca.setBounds(210, 370+y, 100, 25);

	ok.addActionListener(this);
	ca.addActionListener(this);

	p.add(a);
	p.add(ok);
	p.add(ca);

	add(p);

	JPopupMenu popMessage = new JPopupMenu("pme");
	JMenuItem mi0 = new JMenuItem("cut");
	JMenuItem mi1 = new JMenuItem("copy");
	JMenuItem mi2 = new JMenuItem("paste");
	mi0.setActionCommand("cutMessage");
	mi1.setActionCommand("copyMessage");
	mi2.setActionCommand("pasteMessage");
	mi0.addActionListener(this);
	mi1.addActionListener(this);
	mi2.addActionListener(this);
	popMessage.add(mi0);
	popMessage.add(mi1);
	popMessage.add(mi2);
	t.setComponentPopupMenu(popMessage);


	Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
	setLocation((d.width-w)/2, (d.height-h)/2);

	pack();
	setVisible(true);
}

public void insertUpdate(DocumentEvent e)
{
	final Document doc = t.getDocument();
	final Element root = doc.getDefaultRootElement();

	if(root.getElementCount() - MAX_LOG-1 < 0)	return;

	SwingUtilities.invokeLater(new Runnable() {
		public void run() {
			removeLines(doc, root);
		}
	});
}

private void removeLines(Document doc, Element root) {
	Element fl = root.getElement(0);
	final Element fls = root.getElement(MAX_LOG-1);
	final Element fle = root.getElement(root.getElementCount()-1);

	try{
		doc.remove(fls.getEndOffset(), fle.getEndOffset()-fls.getEndOffset()-1);
	}catch(BadLocationException ex) {
		System.out.println(ex+" "+fls.getEndOffset()+" "+fle.getEndOffset());
	}
}

public void removeUpdate(DocumentEvent e){}
public void changedUpdate(DocumentEvent e){}


public void actionPerformed(ActionEvent e)
{
	if(e.getSource() == ok){
		select = SELECT_OK;
		data = t.getText();
		setVisible(false);
	}
	else if(e.getSource() == ca){
		select = SELECT_CANCEL;
		setVisible(false);
	}

	String action = e.getActionCommand();
	if(action.equals("cutMessage"))			t.cut();
	else if(action.equals("copyMessage"))	t.copy();
	else if(action.equals("pasteMessage"))	t.paste();
}

public int getSelect()
{
	return select;
}

public String[] getStrings()
{
	data = data.replaceAll("\n", " \n");
	return data.split("\n");

/*
	int n = data.length();
	while(true){
		if(data.lastIndexOf("\n", n) == 0)	n--;
		else{
			data = data.substring(0, n);
			break;
		}
	}
	return data.split("\n");
/*
	StringTokenizer st = new StringTokenizer(data, "\n");
	if(st.countTokens() == 0)	return null;

	int i = st.countTokens();
	String d[] = new String[i];

	for(int n=0;n<i;n++)
		d[n] = st.nextToken();

	return d;
*/
}

public int getWhere()
{
	if(all.isSelected())			return ALL;
	else if(lobby.isSelected())		return LOBBY;
	else if(field.isSelected())		return FIELD;
	else							return ALL;
}

}
