import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.io.*;
import java.util.*;
import java.awt.geom.*;


public class Base extends Object implements Basis
{
/*
public static final int UNIT	= 2051;			//type
public static final int SCOUT	= 2052;
public static final int LASER	= 2053;
public static final int MISSILE	= 2054;
public static final int EFFECT	= 2055;
*/
public static final int SOS_PARTY	= 2110;		//belong
public static final int PC_STUDYS	= 2111;
public static final int WATCH		= 2112;
public static final int OTHER		= 2113;

public static final Color ALLY_COLOR = new Color(0x88ff88);
public static final Color ENEMY_COLOR = new Color(0xff8888);

public static final double toRADIAN;
public static final double RADIAN360;

protected static Polygon mUnit, mLaser, mEffect;


protected int flag;					//		
protected int self;					//		
protected int type;					//		unit or laser
protected int belong;				//		a or b
protected Point point;				//	ʒu
protected Point2D dpoint;			//	mȈʒu
protected double radian;			//	px
protected double cos;				//	ẍړ
protected double sin;				//	ÿړ
protected double speed;				//	ړ
protected boolean exit;				//	ݏؖ@݂邩



static
{
	int unitX[] = {30, -20, -20};
	int unitY[] = {0, -20, 20};
	mUnit = new Polygon(unitX, unitY, 3);

	int laserX[] = {10, 10, -10, -10};
	int laserY[] = {1, -1, -1, 1};
	mLaser = new Polygon(laserX, laserY, 4);

	int effectX[] = {-4, -5, -3, -5, -4, 0, 4, 5, 3, 5, 4, 0};
	int effectY[] = {5, 4, 0, -4, -5, -3, -5, -4, 0, 4, 5, 3};
	mEffect = new Polygon(effectX, effectY, 12);

	toRADIAN = Math.PI/180.0;
	RADIAN360 = 360.0*toRADIAN;
}
/*
public Base(int flag, int self, int type, int belong, double x, double y, 
											double radian, int speed, boolean exit)
{
	init(flag, self, type, belong, x, y, radian, getSpeed(speed), exit);
}
*/
public Base(int flag, int self, int type, int belong, double x, double y, 
											double radian, double speed, boolean exit)
{
	init(flag, self, type, belong, x, y, radian, speed, exit);
}

public Base(double x, double y)
{
	init(0, 0, EFFECT, 0, x, y, 0, 0, true);
}

protected void init(int flag, int self, int type, int belong, double x, double y, 
											double radian, double speed, boolean exit)
{
	this.flag = flag;
	this.self = self;
	this.type = type;
	this.belong = belong;
	point = new Point((int)x, (int)y);
	dpoint = new Point2D.Double(x, y);

	this.radian = radian;
	cos = Math.cos(radian);
	sin = Math.sin(radian);
	this.speed = speed;
	this.exit = exit;
}


protected static void Transform(Polygon model, Polygon material, double radian)
{
	AffineTransform at = new AffineTransform();
	Point2D po;
	int n;

	at.setToRotation(radian);
	if(material == null)	material = new Polygon();
	else					material.reset();

	for(n=0;n<model.npoints;n++){
		po = at.transform(new Point(model.xpoints[n], model.ypoints[n]), null);
		material.addPoint((int)po.getX(), (int)po.getY());
	}
}


public boolean move(double way)
{
	setMove(dpoint.getX()+cos*way*speed, dpoint.getY()+sin*way*speed);
	return true;//waste();
}

protected void setMove(double x, double y)
{
	dpoint.setLocation(x, y);
	point.setLocation(x, y);
}
/*
protected boolean waste()
{
	if(rest < 0)		return true;
	if((--rest) == 0)	return false;
	return true;
}
*/
public void check()
{
	if(dpoint.getX() < 0)		setMove(0.0, dpoint.getY());
	else if(dpoint.getX() > MW)	setMove(MW, dpoint.getY());

	if(dpoint.getY() < 0)		setMove(dpoint.getX(), 0.0);
	else if(dpoint.getY() > MH)	setMove(dpoint.getX(), MH);
}

public void roll(double value)
{
	radian = examination(radian+value);

	cos = Math.cos(radian);
	sin = Math.sin(radian);
}

public void setRoll(double value)
{
	radian = value;

	cos = Math.cos(radian);
	sin = Math.sin(radian);
}


private static double examination(double value)
{
	return value%RADIAN360;
}


public int getFlag(){				return flag;			}
public int getSelf(){				return self;			}
public int getBelong(){				return belong;			}
public int getX(){					return point.x;			}
public int getY(){					return point.y;			}
public boolean getExit(){			return exit;			}
public Point getPoint(){			return point;			}
public Point2D getPoint2D(){		return dpoint;			}
public static double getSpeed(double speed){		return speed/80.0+0.3;	}
public static double getRadian(double angle){		return angle*toRADIAN;	}

public void death(){				exit = false;			}


public static String getStatus(int hp)
{
	String s = hp+"";
	for(int n=s.length();n<5;n++)
		s = "0"+s;
	return s;
}

public void paint(Graphics2D g, int offsetX, int offsetY, int BELONG)
{
	if(!exit)	return;

	AffineTransform at = g.getTransform();
	int x = point.x+offsetX;
	int y = point.y+offsetY;

	g.translate(x, y);
	g.rotate(radian);
	
	g.setColor(getColor(type, belong, BELONG));

	if(type != MISSILE)
			g.fillPolygon(getModel(type));
	else	g.fillArc(-7, -7, 14, 14, 0, 360);

	g.setTransform(at);
}

public void paint(Graphics2D g, int offsetX, int offsetY, int BELONG, int hp, String name)
{
	if(!exit)	return;

	AffineTransform at = g.getTransform();
	int x = point.x+offsetX;
	int y = point.y+offsetY;

	g.translate(x, y);
	g.rotate(radian);
	

	g.setColor(getColor(type, belong, BELONG));

	if(type != MISSILE)
		g.fillPolygon(getModel(type));

	else	g.fillArc(-7, -7, 14, 14, 0, 360);

	g.setTransform(at);

	if(type == UNIT){
		g.setColor(Color.yellow);
		FontMetrics fm = g.getFontMetrics();
		String data = getStatus(hp);

		if(belong == SOS_PARTY){
			g.drawString(data, x-fm.stringWidth(data)/2, y+38);
			g.drawString(name, x-fm.stringWidth(name)/2, y+50);
		}
		else{
			g.drawString(data, x-fm.stringWidth(data)/2, y-38);
			g.drawString(name, x-fm.stringWidth(name)/2, y-50);
		}
	}
}

private static Color getColor(int type, int belong, int BELONG)
{
	if(type == UNIT){
		switch(belong){
			case SOS_PARTY:		return Color.red;
			case PC_STUDYS:		return new Color(0x66, 0x66, 0x66);
			default:			return Color.orange;
		}
	}
	else if(type == LASER || type == MISSILE){
		if(belong == BELONG)	return ALLY_COLOR;
		else					return ENEMY_COLOR;
	}
	return Color.black;
}

private static Polygon getModel(int type)
{
	switch(type){
		case UNIT:		return mUnit;
		case LASER:		return mLaser;
		case EFFECT:	return mEffect;
		default:		return null;
	}
}

public String getCode()
{
	return flag+P+self+P+type+P+belong+P+dpoint.getX()+P+dpoint.getY()+P+radian+P+speed+P+exit;
}

}