import java.awt.*;
import java.awt.geom.*;


public class Beam extends Base implements Basis
{

public static final Color view = new Color(0x88, 0xff, 0x88);
public static final Color enemy = new Color(0xff, 0x88, 0x88);

private static Polygon model;

protected int etc;
private Polygon beam;
//private Point2D start, end;


static
{
	int pointX[] = {10, 10, -10, -10};
	int pointY[] = {1, -1, -1, 1};

	model = new Polygon(pointX, pointY, 4);
}

public Beam(int flag, int self, int belong, int x, int y, double radian, boolean exit, int etc)
{
	super(flag, self, BEAM, belong, 
		(int)(x + Math.cos(radian)*40), 
		(int)(y + Math.sin(radian)*40), 
		radian, getSpeed(120), exit);

	this.etc = etc;
	beam = new Polygon();
	Transform(model, beam, radian);

//	start = new Point2D.Double((beam.xpoints[1]+beam.xpoints[2])/2, (beam.ypoints[1]+beam.ypoints[2])/2);
//	end = new Point2D.Double((beam.xpoints[0]+beam.xpoints[3])/2, (beam.ypoints[0]+beam.ypoints[3])/2);
}

public boolean move()
{
	if(etc < 0)	return false;

	move(4);

	if(point.x < -10)	return false;
	if(point.y < -10)	return false;
	if(MW+10 < point.x)	return false;
	if(MH+10 < point.y)	return false;
	etc--;

	return true;
}

public Polygon getPolygon(){	return beam;	}
//public Point2D getStart(){		return start;	}
//public Point2D getEnd(){		return end;		}

/*
public void paint(Graphics2D g, int x, int y)
{
	laser.translate(point.x+x, point.y+y);

	setLaserColor(g, belong);
	g.fillPolygon(laser);

	laser.translate(-(point.x+x), -(point.y+y));
}
*/
private void setBeamColor(Graphics2D g, int belong)
{
	if(belong < 6)	g.setColor(view);
	else			g.setColor(enemy);
}

public String getCode()
{
//	return flag+P+self+P+type+P+belong+P+dpoint.getX()+P+dpoint.getY()+P+radian+P+speed+P+exit;
	return MAKE_BEAM+P+super.getCode()+P+etc;
}

}
