import java.io.*;
import java.net.*;
import java.awt.*;
import java.awt.im.*;
import java.awt.image.*;
import java.awt.event.*;
import java.awt.geom.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;
import static java.awt.RenderingHints.*;

@SuppressWarnings({"unchecked", "serial"})

public class Client extends JPanel
	implements Runnable, ActionListener, MouseListener, MouseMotionListener, Basis
{

private JFrame f;
private Thread t;

private static Client cl;
private static Scene sc;
private KeyData kd;

private boolean Process;


public Client(JFrame f, KeyData k)
{
	super();

	this.f = f;
	cl = this;
	kd = k;
	Contract();
}

public void Contract()
{
	setPreferredSize(new Dimension(WW, WH));

	t = new Thread(this);
	sc = new Begin();

	kd.setScene(sc);

	Scene.setInit();
	Scene.setClient(f, this, t);
	Scene.setKeyData(kd);

	Process = true;

	setFocusable(true);
	addMouseListener(this);
	addMouseMotionListener(this);
	addKeyListener(kd);
	t.start();
}



public void run()
{
	Scene s;

	sc = new Entrance();

	while(Process){
		kd.setScene(sc);
		s  = sc.MainLoop();
		Function.TestString("test.");

		if(s == sc){
			Exit();
			return;
		}
		else if(s == null){
			if(!sc.getError())	sc.setClientError(ERR_ABNORMALITY);
			Exit();
			return;
		}

		sc = s;
	}
}



public void actionPerformed(ActionEvent e)
{
	sc.ActionPerformed(e);
}



public void mouseMoved(MouseEvent e)
{
	sc.MouseMoved(e);
}

public void mouseDragged(MouseEvent e)
{

}



public void mousePressed(MouseEvent e)
{
	sc.MousePressed(e);
}

public void mouseReleased(MouseEvent e)
{
	sc.MouseReleased(e);
}

public void mouseClicked(MouseEvent e)
{

}

public void mouseEntered(MouseEvent e)
{

}

public void mouseExited(MouseEvent e)
{

}



public void update(Graphics G)
{
//	if(Scene.getScene() != LOBBY)
		paintComponent(G);
}

public void paintComponent(Graphics G)
{
	super.paintComponent(G);

	G.drawImage(Scene.getOffScreen(), 0, 0, null);
}


public void setTitle(String data)
{
	f.setTitle(data);
}

public void ExitProcess()
{
	Process = false;
}

private static synchronized void Exit()
{
	subExit();

	boolean show = true;
	String message = "G[܂";
	String title = "T[o[֘ÃG[";

	switch(Scene.getServerError()){
		case ERR_ABNORMALITY:	message = "G[܂\n"+getErrorCode();	break;
		case ERR_NODATA:		message = "s\̃G[܂";			break;
		case ERR_KICK:			show = false;										break;
		case ERR_TIMEOUT:		message = "VOi^CAEg";					break;
		case ERR_SERVER:		message = "T[o[I܂";					break;
		case ERR_NOMAL:
		default:

		title = "NCAg֘ÃG[";

		switch(Scene.getClientError()){
			case ERR_NOMAL:			show = false;	break;
			case ERR_ABNORMALITY:	message = "G[܂\n"+getErrorCode();		break;
			case ERR_NODATA:		message = "s\̃G[܂\n"+getErrorCode();	break;
			case ERR_EOF:			message = "T[o[̃f[^[ǍɎs܂";	break;
			case ERR_IO:			message = "T[o[Ƃ̐ڑG[";						break;
			default:				message = "RsȏI\n"+getErrorCode();			break;
		}
	}
	
	Toolkit.getDefaultToolkit().beep();
	if(show)	Function.Dialog(message, title);

	Function.TestString("Client-Exit, exit. "+getErrorCode());

	System.exit(0);
}

public static synchronized void subExit()
{
	if(sc != null)	sc.ExitProcess();
	if(cl != null)	cl.ExitProcess();

	sc.LastProcess();
	Function.LogStreamClose();	
}

public static synchronized String getErrorCode()
{
	return "error code "+Scene.getError()+" s "+Scene.getServerError()+" c "+Scene.getClientError();
}

}
