import java.io.*;
import java.net.*;
import java.awt.*;
import java.awt.im.*;
import java.awt.image.*;
import java.awt.event.*;
import java.awt.geom.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;
import static java.awt.RenderingHints.*;

@SuppressWarnings({"unchecked", "serial"})

public class Entrance extends Begin
{

public static final String ImageName = "picture.png";
//public static final String ImageName = "entrance.png";
//public static final String ImageName2 = "title.png";
public static final int TW = 600;
public static final int TH = 100;
public static final int EW = 600;
public static final int EH = 250;
public static final int BGW = 800;
public static final int BGH = 850;

private BufferedImage im;//, bg;
private MyButton mb[];
private boolean id;


public Entrance()
{
	super(ENTRANCE, DEFAULT_LOOP);

	id = false;
//	im = new ImageIcon(ImageName).getImage();
	im = getImageFile(ImageName);
	if(im == null)	im = getImage(ImageName);

	if(im != null){
		if(BGW == im.getWidth() || BGH == im.getHeight())	id = true;
		else if(EW > im.getWidth() || EH > im.getHeight()){
			Function.Dialog(ImageName+"̃TCY܂B\n"+
						"Kl "+EW+"~"+EH+" or "+BGW+"~"+BGH, "x"
			);
			im = null;
		}
	}

/*	bg = getImage(ImageName2);
	if(bg != null){
		if(BGW > bg.getWidth() || BGH > bg.getHeight()){
			Function.Dialog("titlẻ摜̃TCY܂B\nKl "+BGW+"~"+BGH, "x");
			bg = null;
		}
	}
*/
	mb = new MyButton[3];
	mb[0] = new MyButton("Jn", "start", 300, 300, 0);
	mb[1] = new MyButton("Ǎ", "load", 300, 370, 1);
	mb[2] = new MyButton("I", "exit", 300, 440, 2);

/*	while(true){
		if(OffScreen != null && g != null)	break;
		Thread.yield();
	}
*/
	InitProcess();
}


public void InitProcess()
{
	paint();
	repaint();
}

public void EndProcess()
{
	g.setColor(new Color(0xeeeeee));
	g.fillRect(0, 0, WW, WH);
	repaint();
}

public void LoopProcess()
{
	
}

public void LastProcess()
{

}



public void ActionPerformed(ActionEvent e)
{

}

public void MousePressed(MouseEvent e)
{

}

public void MouseReleased(MouseEvent e)
{
	int x = e.getX();
	int y = e.getY();

	if(mb[0].isHit(x, y))		LobbyRelation();
	else if(mb[1].isHit(x, y))	Function.Dialog("", "mF");
	else if(mb[2].isHit(x, y)){
		ns = this;
		ExitProcess();
	}
}

public void MouseMoved(MouseEvent e)
{
	boolean val = false;
	int x = e.getX();
	int y = e.getY();

	if(mb[0].isActive(x, y))	val = true;
	if(mb[1].isActive(x, y))	val = true;
	if(mb[2].isActive(x, y))	val = true;

	if(val)	InitProcess();
}


public void paint()
{
	g.setColor(new Color(0xeeeeee));
	g.fillRect(0, 0, WW, WH);

	if(im != null){
		if(id)	g.drawImage(im, 0, 0, BGW, BGH-EH, 0, EH, BGW, BGH, null);
		for(int n=0;n<mb.length;n++)	paintImageButton(g, mb[n]);
		g.drawImage(im, 100, 100, 100+TW, 100+TH, 0, 150, 0+TW, 150+TH, null);		
	}
	else{
		paintTitle(g, 100, 100);
		for(int n=0;n<mb.length;n++)	paintButton(g, mb[n]);
	}
}

public void paintImageButton(Graphics2D g, MyButton mb)
{
	g.drawImage(im, mb.getX(), mb.getY(), 
		mb.getX()+MyButton.IW, mb.getY()+MyButton.IH, 
		mb.getImageX(), mb.getImageY(), 
		mb.getImageX()+MyButton.IW, mb.getImageY()+MyButton.IH, null
	);
}

public void paintTitle(Graphics2D g, int x, int y)//x=100, y=100
{
	int width = 600;
	int height = 100;
	
	g.setColor(new Color(128, 128, 255));
	g.fillRoundRect(x, y, width, height, 20, 20);
	g.setColor(new Color(0xeeeeee));
	g.fillRoundRect(x+10, y+10, width-20, height-20, 20, 20);

	g.setFont(new Font("Dialog", Font.PLAIN, 60));
	g.setColor(new Color(64, 64, 64));
	g.drawString("the day of sagittarius", x+20, y+70);
}

public void paintButton(Graphics2D g, MyButton mb)
{
	if(mb.getActive())	g.setColor(new Color(255, 128, 192));
	else				g.setColor(new Color(128, 128, 255));
	g.fillRoundRect(mb.getX(), mb.getY(), MyButton.IW, MyButton.IH, 20, 20);
	g.setColor(new Color(0xffffff));
	g.fillRoundRect(mb.getX()+5, mb.getY()+5, MyButton.IW-10, MyButton.IH-10, 20, 20);

	if(mb.getActive())	g.setColor(new Color(255, 128, 192));
	else				g.setColor(new Color(128, 128, 255));

	g.setFont(new Font("Dialog", Font.PLAIN, 28));
	FontMetrics f = g.getFontMetrics();

	int x = mb.getX() + MyButton.IW/4 - f.stringWidth(mb.getString())/2 + 10;
	int y = mb.getY() + MyButton.IH/2 + f.getHeight()/3;
	g.drawString(mb.getString(), x, y);

	x = mb.getX() + MyButton.IW/4*3 - f.stringWidth(mb.getStringEnglish())/2 - 10;
	y = mb.getY() + MyButton.IH/2 + f.getHeight()/3;
	g.drawString(mb.getStringEnglish(), x, y);
}


public void LobbyRelation()
{
	String data = null;
	LogInDialog ld = new LogInDialog(f);

	if(ld.getSelect() != LogInDialog.SELECT_OK)	return;

	try{
		so = new Socket(ld.getAddress(), PORT);

		so.setTcpNoDelay(true);
		so.setSoLinger(false, LINGER);
		so.setSoTimeout(CLIENT_SIGNAL_TIME_OUT);

		out = new DataOutputStream(
			new BufferedOutputStream(so.getOutputStream()));
		in  = new DataInputStream(
			new BufferedInputStream(so.getInputStream()));
//		out = new DataOutputStream(so.getOutputStream());
//		in = new DataInputStream(so.getInputStream());

		Send(LOGIN+P+VERSION+P+ld.getName());
		data = in.readUTF();
		Function.TestString("Client-LobbyRelation, "+data);
	}
	catch(IOException ex){
		Function.Dialog("T[o[𔭌ł܂ł", "mF");
	}
	catch(Exception ex){
		Function.Dialog("T[o[Ƃ̐ڑɎs܂", "mF");
	}
	if(data == null){
		return;
	}

	StringTokenizer st = new StringTokenizer(data, P);
	if(st.countTokens() < 1)	return;

	switch(Integer.parseInt(st.nextToken())){
		case ERR_VERSION:
			if(st.countTokens() < 1)	return;
			Function.Dialog("NCAg "+VERSION_STR+" \n"+
					"ÑT[o[ "+st.nextToken()+"\n"+
					"o[WmFĐڑĂ", "mF");
			return;
		case ERR_LOGIN:
			Function.Dialog("ɃG[܂", "mF");
			return;
		case LOGIN:		break;
		default:	return;
	}
		
	if(st.countTokens() < 2)	return;

	int flag = Integer.parseInt(st.nextToken());
	String name = st.nextToken();

	cl.setTitle(TITLE+"  "+VERSION_STR+"  "+ld.getAddress()+"  "+name);
	ns = new Lobby(so, out, in, flag, name);
	ExitProcess();
	return;
}

}
