import java.io.*;
import java.net.*;
import java.awt.*;
import java.awt.im.*;
import java.awt.image.*;
import java.awt.event.*;
import java.awt.geom.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;
import static java.awt.RenderingHints.*;

@SuppressWarnings({"unchecked", "serial"})

public class Field extends Begin implements Runnable, Basis
{

private JTextField message;
private JButton exit;
private Thread th;

private FieldMember fmself;
private FieldMember fm[];

protected BufferedImage OffField;
protected Graphics2D gf;
protected static BufferedImage OffStatus;
protected static Graphics2D gs;

private boolean Provess;
private Font font;
private Vector comment;
private int row;
private Color commentColor;

private long time;
private int carry;
private int count;



public Field(FieldMember m)
{
	super(FIELD, FIELD_LOOP);

//	setInitImage(OffField, gf, FW, FH);
//	setInitImage(OffStatus, gs);

	FieldMember.setScene(sc);
//	Process = true;

	fmself = m;
	fm = new FieldMember[MAX_MEMBER];
	fm[fmself.getFlag()] = fmself;
	
	comment = new Vector();
	row = 10;
	commentColor = new Color(0xffffff);
	font = new Font("Dialog", Font.PLAIN, 12);

	time = carry = count = 0;

	th = new Thread(this);
}

public void setPanel()
{
	cl.setLayout(null);
	message = new JTextField();
	message.setBounds(10, 570, 600, 20);
	message.addActionListener(cl);
	cl.add(message);

	exit = new JButton("ގ");
	exit.setBounds(660, 570, 100, 20);
	exit.addActionListener(cl);
	cl.add(exit);

	JPopupMenu popMessage = new JPopupMenu("pme");
	JMenuItem mi0 = new JMenuItem("cut");
	JMenuItem mi1 = new JMenuItem("copy");
	JMenuItem mi2 = new JMenuItem("paste");

	mi0.setActionCommand("cutMessage");
	mi1.setActionCommand("copyMessage");
	mi2.setActionCommand("pasteMessage");

	mi0.addActionListener(cl);
	mi1.addActionListener(cl);
	mi2.addActionListener(cl);

	popMessage.add(mi0);
	popMessage.add(mi1);
	popMessage.add(mi2);
	message.setComponentPopupMenu(popMessage);

	cl.addFocusListener(new TransformModeFocusListener(cl, kd, TransformModeFocusListener.IM_OFF));
}

public void run()
{
	String data;
	try{
		while(Process){
			data = in.readUTF();
			if(data != null)		Process(data);
		}
		return;
	}
	catch(EOFException ex){	setClientError(ERR_EOF);			}
	catch(IOException ex){
		if(getScene() != EXIT)	setClientError(ERR_IO);
		Function.TestString("Field-run, err IO");
	}
	catch(Exception ex){
		setClientError(ERR_ABNORMALITY);
		Function.TestString("Field-run, err abnormality");
		ex.printStackTrace();
	}
	Function.TestString("Field-run, end.");
	ns = this;
	ExitProcess();
}

private void Process(String data)
{
	StringTokenizer st = new StringTokenizer(data, P);

	if(st.countTokens() < 1){
		Function.TestString("Field-Process, There is no value. "+data);
		return;
	}

	int n = Function.Extraction(st.nextToken());

	if(n != SIGNAL)
		Function.TestString("Field-Process, "+data);

	switch(n){
		case SIGNAL:			AnalysisSignalCode();			break;
//		case CHAT:				AnalysisChatCode(st);			break;
		case CHAT_SERVER:		AnalysisChatServerCode(st);		break;
		case CHAT_FIELD:		AnalysisFieldChatCode(st);		break;
		case CHAT_NAMELESS:		AnalysisNamelessChatCode(st);	break;
//		case CHAT_SERVER_FIELD:	AnalysisChatServerCode(st);		break;
		case LOGIN:				AnalysisLoginCode(st);			break;
		case LOGOUT:			AnalysisLogoutCode(st);			break;
		case LOGIN_FIELD:		AnalysisFieldLoginCode(st);		break;
		case LOGOUT_FIELD:		AnalysisFieldLogoutCode(st);	break;

		case ERR_ABNORMALITY:
		case ERR_KICK:
		case ERR_TIMEOUT:
		case ERR_NODATA:
		case ERR_SERVER:		AnalysisErrCode(n);				break;

		case ERR:	Function.TestString("integet error : "+data);	break;

		case SPEED:
		case ROLL:
		case LASER:
		case HP:
			Analysis(n, st);
			break;

		default:
			Function.TestString("no data "+data);
			break;
	}
}

public void Analysis(int data, StringTokenizer st)
{
	if(st.countTokens() < 1)	return;
	int flag = Function.Extraction(st.nextToken());

	if(flag == ERR)			return;
	if(fm[flag] == null)	return;

	switch(data){
		case SPEED:		fm[flag].AnalysisSpeedChange(st);		break;
		case ROLL:		fm[flag].AnalysisRoll(st);				break;
		case LASER:		fm[flag].AnalysisLaser(st);				break;
		case HP:		fm[flag].AnalysisHp(st);				break;
	}
}

public void AnalysisLoginCode(StringTokenizer st)
{
	if(st.countTokens() != 4){
		Function.TestString("Field-AnalysisLoginCode, The number of values is abnormal. "+st.countTokens());
		return;
	}

	try{
		int flag = Integer.parseInt(st.nextToken());
		int status = Integer.parseInt(st.nextToken());
		int area = Integer.parseInt(st.nextToken());
		String name = st.nextToken();

		cm[flag] = new ClientMember(flag, status, area, name);
//		addText(name+" entered a room.");
//		update = true;
	}
	catch(Exception ex){
		Function.TestString("Field-AnalysisLoginCode, The value is strange.");
		ex.printStackTrace();
	}
}
public void AnalysisFieldLoginCode(StringTokenizer st)
{
	if(st.countTokens() != 15){
		Function.TestString("Field-AnalysisFieldLoginCode, The number of values is abnormal. "+st.countTokens());
		return;
	}

	try{
		int flag = Integer.parseInt(st.nextToken());
		int self = Integer.parseInt(st.nextToken());
		int type = Integer.parseInt(st.nextToken());
		int belong = Integer.parseInt(st.nextToken());
		double x = Double.parseDouble(st.nextToken());
		double y = Double.parseDouble(st.nextToken());
		double radian = Double.parseDouble(st.nextToken());
		double speed = Double.parseDouble(st.nextToken());
		boolean exit = Boolean.parseBoolean(st.nextToken());
		int hp = Integer.parseInt(st.nextToken());
		int atc = Integer.parseInt(st.nextToken());
		int def = Integer.parseInt(st.nextToken());
		int spd = Integer.parseInt(st.nextToken());
		int way = Integer.parseInt(st.nextToken());
		int area = Integer.parseInt(st.nextToken());

		cm[flag].setStatus(FIELD);
		cm[flag].setArea(area);

		if(area != cmself.getArea())	return;

		FieldMember fmenemy = new FieldMember(cm[flag].getName(), false, 
				flag, belong, hp, atc, def, spd, way, x, y, radian, speed, exit);
		fm[flag] = fmenemy;

		addText(cm[flag].getName()+" entered a room.");
	}
	catch(Exception ex){
		Function.TestString("Field-AnalysisFieldLoginCode, The value is strange.");
		ex.printStackTrace();
	}
}

public void AnalysisLogoutCode(StringTokenizer st)
{
	if(st.countTokens() < 2){
		Function.TestString("Field-AnalysisLogoutCode, The number of values is abnormal. "+st.countTokens());
		return;
	}

	try{
		int flag = Integer.parseInt(st.nextToken());
		int status = Integer.parseInt(st.nextToken());
		Function.TestString("Field-AnalysisLogoutCode, a.");

		if(cm[flag] == null)	return;
		if(cm[flag].getStatus() == FIELD && cm[flag].getArea() == cmself.getArea())
			addText(cm[flag].getName()+" leaves a room.");
		
		if(fm[flag] != null)	fm[flag] = null;
		cm[flag] = null;
	}
	catch(Exception ex){
		Function.TestString("Field-AnalysisLogoutCode, The value is strange.");
		ex.printStackTrace();
	}
}

public void AnalysisFieldLogoutCode(StringTokenizer st)
{
	if(st.countTokens() < 1){
		Function.TestString("Field-AnalysisLogoutCode, The number of values is abnormal. "+st.countTokens());
		return;
	}

	try{
		int flag = Integer.parseInt(st.nextToken());

		if(cm[flag] == null)	return;
		if(cm[flag].getStatus() == FIELD && cm[flag].getArea() == cmself.getArea())
			addText(cm[flag].getName()+" leaves a room.");
		
		if(fm[flag] != null)	fm[flag] = null;
		cm[flag].setStatus(LOBBY);
		cm[flag].setArea(FIELD_NULL);

		if(flag == cmself.getFlag()){
			ns = new Lobby();
			ExitProcess();
		}
	}
	catch(Exception ex){
		Function.TestString("Field-AnalysisLogoutCode, The value is strange.");
		ex.printStackTrace();
	}
}

private void AnalysisErrCode(int err)
{
	setServerError(err);
	ns = this;
	ExitProcess();
}






public void AnalysisFieldChatCode(StringTokenizer st)
{
	if(st.countTokens() < 3){
		Function.TestString("Field-AnalysisFieldChatCode, The number of values is abnormal. "+st.countTokens());
		return;
	}

	try{
		int flag = Integer.parseInt(st.nextToken());
		int who = Integer.parseInt(st.nextToken());
		String data = st.nextToken();

		switch(who){
			case ALL:	Function.TestString("Field-AnalysisFieldChatCode, "+who+" "+data);		break;
			case GROUP:	Function.TestString("Field-AnalysisFieldChatCode, "+who+" "+data);		break;
			default:	return;
		}
		if(fm[flag] == null)	return;

		addText(fm[flag].getName()+" : "+data);
	}
	catch(Exception ex){
		Function.TestString("Field-AnalysisFieldChatCode, The value is strange.");
		ex.printStackTrace();
		return;
	}
}

private void AnalysisChatServerCode(StringTokenizer st)
{
	if(st.countTokens() < 1)	return;
	addText(SERVER_NAME+" : "+st.nextToken());
}

private void AnalysisNamelessChatCode(StringTokenizer st)
{
	if(st.countTokens() != 1)	return;
	addText(NUSIGUED_NAME+" : "+st.nextToken());
}





public synchronized void addText(String data)
{
	Function.LogWrite(FORTH+data+"\n");
	comment.add(data);

	while(true){
		if(MAX_COMMENT < comment.size())	comment.remove(0);
		else					return;
	}
}

protected void InitProcess()
{
	StartProcess();
	setPanel();
	th.start();

	OffField = new BufferedImage(FW, FH, BufferedImage.TYPE_INT_BGR);
	gf = OffField.createGraphics();
	gf.setRenderingHint(KEY_ANTIALIASING, VALUE_ANTIALIAS_ON);

	Function.TestString("Field-InitProcess,");
}

protected void LoopProcess()
{
	Send(SIGNAL+"");
}

protected void EndProcess()
{
	Function.TestString("Field-EndProcess, s.");
	cl.removeAll();
	repaint();
	Function.TestString("Field-EndProcess, e.");
}

public void LastProcess()
{
	Close(ERR_CLIENT+"");
}

public void KeyEnterEvent()
{
	kd.AllReleased();
//	FocusEvent aEvent = new FocusEvent(message, FocusEvent.FOCUS_GAINED);
//	Toolkit.getDefaultToolkit().getSystemEventQueue().postEvent(aEvent);
	Focus(message);
	Function.TestString("Field-KeyEnterEvent, test");
}



public void ActionPerformed(ActionEvent e)
{
	if(e.getSource() == message){
		if(textCeck(message.getText())){
			if(message.getText().length() == 0){
//				FocusEvent aEvent = new FocusEvent(cl, FocusEvent.FOCUS_GAINED);
//				Toolkit.getDefaultToolkit().getSystemEventQueue().postEvent(aEvent);
				Focus(cl);
			}
			else	message.setText("");
			return;
		}
		Send(CHAT_FIELD+P+cmself.getFlag()+P+ALL+P+message.getText());
		message.setText("");
	}
	else if(e.getSource() == exit){
		Send(LOGOUT_FIELD+P+cmself.getFlag());
		exit.setEnabled(false);
	}
}

private boolean textCeck(String data)
{
	if(message.getText().length() == 0);
	else if(data.indexOf("/") == 0);
	else	return false;

	StringTokenizer st = new StringTokenizer(data, PT);
	if(st.countTokens() < 1)	return true;
	String d = st.nextToken();

	if(d.equals("/font"))			setFont(st, data);
	else if(d.equals("/save"))		Function.saveData(Gather(comment));
	else if(d.equals("/repaint"))	repaint();
	else if(d.equals("/color"))		setColor(st, data);
	else if(d.equals("/log"))		setLog(st);
	else if(d.equals("/AA")){
		if(st.countTokens() != 0)	return true;
		AreaDialog();
	}
	else if(d.equals("/-")){
		if(st.countTokens() < 1)	return true;
		Send(CHAT_NAMELESS+P+FIELD+P+message.getText().substring("/-".length()+1));
	}
 	else if(d.equals("/input")){
 		if(st.countTokens() < 1)	return true;
 		Send(PRESERVE_FIELD+P+cmself.getFlag()+P+message.getText().substring("/input".length()+1));		
 	}

	return true;
}

public void setFont(StringTokenizer st, String data)
{
	Font fo = Function.setFont(st, data, font);
	if(fo == null){
		String sty = "";
		switch(font.getStyle()){
			case Font.PLAIN:			sty += "plain";			break;
			case Font.BOLD:				sty += "bold";			break;
			case Font.ITALIC:			sty += "italic";			break;
			case Font.BOLD+Font.ITALIC:	sty += "bold and italic";	break;
		}

		addText("It changed to size "+font.getSize()+sty+" of font "+font.getName()+".");
	}
	else	font = fo;
}

public void AreaDialog()
{
	AreaDialog ad = new AreaDialog(f, font, CLIENT);

	if(ad.getSelect() != AreaDialog.SELECT_OK)	return;

	String data[] = ad.getStrings();

	for(int n=0;n<data.length;n++)
		Send(CHAT_LOBBY+P+cmself.getFlag()+P+data[n]);
}

public void setColor(StringTokenizer st, String all)
{
	Color c = Function.setColor(st, all, commentColor);

	if(c == null){
		
		String r = Integer.toString(commentColor.getRed(), 16);
		String g = Integer.toString(commentColor.getGreen(), 16);
		String b = Integer.toString(commentColor.getBlue(), 16);

		if(r.length() == 1)	r = "0"+r;
		if(g.length() == 1)	g = "0"+g;
		if(b.length() == 1)	b = "0"+b;

		String d = r+g+b;
		d = "#"+d.toUpperCase();
		d = " color data "+d+" or ";
		d += commentColor.getRed()+" "+commentColor.getGreen()+" "+commentColor.getBlue()+".";

		addText(d);
		return;
	}
	else	commentColor = c;
}

public void setLog(StringTokenizer st)
{
	int n = Function.setLog(st);

	switch(n){
		case ERR:										break;
		case -2:	row = 10;							break;
		case -3:	addText("log limit "+row+".");		break;
		case -4:	row = MAX_COMMENT;					break;
		default:	if(0 <= n && n <= MAX_COMMENT)	row = n;
	}
}

private String Gather(Vector c)
{
	String data = "";

	for(int n=0;n<comment.size();n++)
		data += (String)comment.elementAt(n)+"\n";

	return data;
}


public void MousePressed(MouseEvent e)
{
	Focus(cl);
	kd.AllReleased();
}

public void MouseReleased(MouseEvent e)
{

}

public void MouseMoved(MouseEvent e)
{

}




public void AnalysisSignalCode()
{
	int n;
	for(n=0;n<fm.length;n++){
		if(fm[n] == null)	continue;	
		fm[n].move();
		fm[n].laser();
	}

//	if(!(fmself.getBelong() == WATCH || !oneself)){
		fmself.setMaterial(true);
		if(fmself.laser != null)	
			Function.TestString("Field-AnalysisSignalCode, self "+fmself.laser.getX()+" "+fmself.laser.getY());
		for(n=0;n<fm.length;n++){
			if(fm[n] == null)	continue;	
//			if(fmself.getBelong() == fm[n].getBelong())	continue;

//			if(fm[n].isHitLaser(fmself.getMaterial(), fmself.getPoint()))
			if(fm[n].laser == null)	continue;
			if(fm[n].laser.getScene() < Laser.store)	continue;
			Function.TestString("Field-AnalysisSignalCode, enemy "+fm[n].laser.getPolygonString());
			if(fm[n].laser.getPolygon().contains(fmself.getPoint()))
				fmself.SendDamage(n, LASER);
		}
		fmself.setMaterial(false);
//	}


	KeyEvent();

	carry = (int)(System.currentTimeMillis()-time-LoopTime);
	time = System.currentTimeMillis();

	if(carry > LoopTime*2){
		carry = 0;
		count++;
		if(count < 5)	return;
	}
	
	if(gf != null)	paintField(gf);
	else	Function.TestString("Field-repaint,");
	count = 0;

	repaint();
}

public void KeyEvent()
{
	if(kd.getUp())		fmself.SendSpeedChange(1);
	if(kd.getDown())	fmself.SendSpeedChange(-1);
	if(kd.getRight())	fmself.SendRoll(1);
	if(kd.getLeft())	fmself.SendRoll(-1);

	if(kd.getEnter());
	if(kd.getShift())	fmself.SendSpeedChange(0);
	if(kd.getZ())		fmself.SendLaser();
	if(kd.getX());
}

public void paintField(Graphics2D g)
{
	Rectangle2D r = new Rectangle2D.Double(0.0, 0.0, (double)FW, (double)FH);
	g.setClip(r);
	g.setFont(font);

	g.setColor(new Color(0x000000));
	g.fillRect(0, 0, FW, FH);

	if(fmself == null)	return;
	int n;
	int offsetX = getOffset(fmself.getX(), FW, MW);
	int offsetY = getOffset(fmself.getY(), FH, MH);

	g.setColor(new Color(0x002222));
	for(n=offsetX%50;n<MW;n+=50)	g.drawLine(n, 0, n, FH);
	for(n=offsetY%50;n<MH;n+=50)	g.drawLine(0, n, FW, n);

/*
	GeneralPath gp = new GeneralPath();
//	gp.append(r, false);

//	for(n=0;n<members.size();n++)
//		gp.append(((Member)members.elementAt(n)).getScout(offsetX, offsetY), true);
	for(Member m:members){
		if(!m.getExist())	continue;
		gp.append(m.getScout(offsetX, offsetY), true);
	}
	for(n=0;n<scouts.size();n++)
		gp.append(((Scout)scouts.elementAt(n)).getScout(offsetX, offsetY), true);

	g.setClip(gp);
*/

	g.setColor(new Color(0x222222));
	g.fillRect(0, 0, FW, FH);

	g.setColor(new Color(0x224444));
	for(n=offsetX%50;n<MW;n+=50)	g.drawLine(n, 0, n, FH);
	for(n=offsetY%50;n<MH;n+=50)	g.drawLine(0, n, FW, n);



//	for(n=0;n<scouts.size();n++)
//		((Scout)scouts.elementAt(n)).paint(g, offsetX, offsetY, self.getNumber());

	for(n=0;n<fm.length;n++){
		if(fm[n] == null)	continue;	
		fm[n].paint(g, offsetX, offsetY, fm[n].getBelong(), fm[n].getHp(), fm[n].getName());
	}

	for(n=0;n<fm.length;n++){
		if(fm[n] == null)	continue;	
		fm[n].paint(g, offsetX, offsetY, LASER);
	}

//	for(n=0;n<missiles.size();n++)
//		((Base)missiles.elementAt(n)).paint(g, offsetX, offsetY);

//	for(n=0;n<effects.size();n++)
//		((Base)effects.elementAt(n)).paint(g, offsetX, offsetY);


	g.setClip(r);

	g.setColor(new Color(0xffffff));
	g.drawString(fmself.getX()+" : "+fmself.getY(), FW-100, 30);

	g.setColor(commentColor);
	int val = comment.size()-row;
	if(val < 0)	val = 0;
	for(n=comment.size()-1;n>=val;n--)
		g.drawString((String)comment.elementAt(n), 20, (n-val)*g.getFont().getSize()+30);

}

private int getOffset(int point, int window, int field)
{
	return Math.max(Math.min((int)(window/2 - point), 0), window-field);
}



public void repaint()
{
 	g.drawImage(OffField, 10, 10, null);

	super.repaint();
}

protected void ExitProcess()
{
	Process = false;
	super.ExitProcess();
}

}
