import java.io.*;
import java.net.*;
import java.awt.*;
import java.awt.im.*;
import java.awt.image.*;
import java.awt.event.*;
import java.awt.geom.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;
import static java.awt.RenderingHints.*;

@SuppressWarnings({"unchecked", "serial"})

public class FieldMember extends Unit implements Basis
{

private static Scene sc;

protected String name;




public static void setScene(Scene s)
{
	sc = s;
}


public FieldMember(String name, boolean oneself, int flag, int belong, int hp, 
	int atc, int def, int spd, int way, double x, double y, double radian, double speed, boolean exit)
{
	super(oneself, flag, belong, hp, atc, def, spd, way, x, y, radian, speed, exit);
	this.name = name;
}

public String getName(){	return name;	}



public void SendSpeedChange(int n)
{
	if(!getExit())	return;

	if(n > 0)		sc.Send(SPEED+P+flag+P+UP);
	else if(n < 0)	sc.Send(SPEED+P+flag+P+DOWN);
	else if(n == 0)	sc.Send(SPEED+P+flag+P+STOP);
}

public void SendRoll(int n)
{
	if(!getExit())	return;

	if(n < 0)		sc.Send(ROLL+P+flag+P+ROLL_LEFT);
	else if(n > 0)	sc.Send(ROLL+P+flag+P+ROLL_RIGHT);
}

public void SendLaser()
{
	if(!getExit())	return;

	sc.Send(LASER+P+flag);
}

public void SendDamage(int enemy, int type)
{
	if(!getExit())	return;

	sc.Send(DAMAGE+P+flag+P+enemy+P+type);
}


public void AnalysisSpeedChange(StringTokenizer st)
{
	if(st.countTokens() != 1){
		Function.TestString("ServerMemver-AnalysisSpeedChange, The number of values is abnormal. "+st.countTokens());
		return;
	}

	try{
		int data = Integer.parseInt(st.nextToken());

		setWay(data);
	}
	catch(Exception ex){
		Function.TestString("ServerMemver-AnalysisSpeedChange, The value is strange.");
		ex.printStackTrace();
		return;
	}
}

public void AnalysisRoll(StringTokenizer st)
{
	if(st.countTokens() != 1){
		Function.TestString("ServerMemver-AnalysisFieldLoginCode, The number of values is abnormal. "+st.countTokens());
		return;
	}

	try{
		double data = Double.parseDouble(st.nextToken());

		setRoll(data);
	}
	catch(Exception ex){
		Function.TestString("ServerMemver-AnalysisFieldLoginCode, The value is strange.");
		ex.printStackTrace();
		return;
	}
}

public void AnalysisLaser(StringTokenizer st)
{
	if(st.countTokens() != 3){
		Function.TestString("ServerMemver-AnalysisFieldLoginCode, The number of values is abnormal. "+st.countTokens());
		return;
	}

	try{
		int x = Integer.parseInt(st.nextToken());
		int y = Integer.parseInt(st.nextToken());
		double radian = Double.parseDouble(st.nextToken());

		laser = new Laser(flag, x, y, radian);
	}
	catch(Exception ex){
		Function.TestString("ServerMemver-AnalysisFieldLoginCode, The value is strange.");
		ex.printStackTrace();
		return;
	}
}

public void AnalysisHp(StringTokenizer st)
{
	if(st.countTokens() != 1){
		Function.TestString("ServerMemver-AnalysisFieldLoginCode, The number of values is abnormal. "+st.countTokens());
		return;
	}

	try{
		int hp = Integer.parseInt(st.nextToken());

		this.hp = hp;
		if(hp < 0)	exit = false;
	}
	catch(Exception ex){
		Function.TestString("ServerMemver-AnalysisFieldLoginCode, The value is strange.");
		ex.printStackTrace();

		return;
	}
}

}
