import java.io.*;
import java.net.*;
import java.awt.*;
import java.awt.im.*;
import java.awt.image.*;
import java.awt.event.*;
import java.awt.geom.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;
import java.util.*;
import static java.awt.RenderingHints.*;


class JTextAreaScroll extends JTextArea
{

public static final int LOG_BASIS = 100;

private int width;
private int limit;
private boolean scroll;
//private PlainDocument pd;
private Document pd;
private Element root;

private boolean highlight;
private String data;
private Highlighter.HighlightPainter highlightPainter;


public JTextAreaScroll(PlainDocument d, int limit)
{
	super(d);
	pd = d;
	root = pd.getDefaultRootElement();
	scroll = true;
	highlight = false;
	highlightPainter = new DefaultHighlighter.DefaultHighlightPainter(new Color(200, 200, 255));

	setLimit(limit);
}

public void setLimit(int l)
{
	limit = l;
	addTextSub(getSelectionStart(), getSelectionEnd());
}

public void setLimit()
{
	limit = LOG_BASIS;
	addTextSub(getSelectionStart(), getSelectionEnd());
}

public int getLimit()
{
	return limit;
}

public void setWidth(int w)
{
	width = w-20;	//XN[o[̕
}

public boolean setScroll(boolean s)
{
	if(scroll == s)	return false;

	scroll = s;
	return true;
}

public boolean getScroll()
{
	return scroll;
}

public void changeScroll()
{
	if(scroll)	scroll = false;
	else		scroll = true;
}

public void changeTurn()
{
	if(getLineWrap())	setLineWrap(false);
	else				setLineWrap(true);
}

public boolean setTurn(boolean wsw)
{
	setLineWrap(wsw);
/*
	if(getLineWrap() == wsw)	return false;
	else						super.setLineWrap(wsw);
*/
	return true;
}

public void setHighlighter(String data)
{
	removeHighlights(false);
	highlight = true;
	this.data = data;

	try{
		Highlighter hilite = this.getHighlighter();
		String text = pd.getText(0, pd.getLength());
		int pos = 0;
		while((pos = text.indexOf(data, pos)) >= 0) {
			hilite.addHighlight(pos, pos+data.length(), highlightPainter);
			pos += data.length();
		}
		addText(data+" is set to the highlight.");
	}
	catch(BadLocationException e){
	}
}

public void addHighlighter()
{
	removeHighlights(false);
	highlight = true;
	try{
		Highlighter hilite = this.getHighlighter();
		String text = pd.getText(0, pd.getLength());
		int pos = 0;
		while((pos = text.indexOf(data, pos)) >= 0) {
			hilite.addHighlight(pos, pos+data.length(), highlightPainter);
			pos += data.length();
		}
	}
	catch(BadLocationException e){
	}
}

public void removeHighlights(boolean is)
{
	highlight = false;
	Highlighter hilite = this.getHighlighter();
	Highlighter.Highlight[] hilites = hilite.getHighlights();
	for(int i=0;i<hilites.length;i++) {
		if(hilites[i].getPainter() instanceof DefaultHighlighter.DefaultHighlightPainter) {
			hilite.removeHighlight(hilites[i]);
		}
	}
	if(is)	addText("The highlight is released.");
}

public synchronized void addText(String str)
{
	try{
		int s = getSelectionStart();
		int e = getSelectionEnd();

		pd.insertString(pd.getLength(), str+"\n", null);
		addTextSub(s, e);
	}
	catch(Exception ex){
		System.out.println("err");
	}
//		final Document doc = getDocument();
//		final Element root = doc.getDefaultRootElement();
/*
		int n = removeLines(pd, root);

		if(highlight)	addHighlighter();

		if(scroll)	setCaretPosition(pd.getLength());
		else{
//			if(e != 0)
//			select(s, e);
			setCaretPosition(0);

			s -= n;
			e -= n;

			if(s < 0)	s = 0;
			if(e < 0)	e = 0;
			if(s < e)
			select(s, e);
		}
	}
	catch(Exception ex){
		System.out.println("err");
	}
/*
//	this.insert(str+"\n", pd.getLength());
	this.append(str+"\n");

	Rectangle rec = this.getVisibleRect();
	FontMetrics fm = this.getFontMetrics(this.getFont());
	int n, y, count = 0;

	if(getLineWrap())	n = fm.stringWidth(str)/width+1;//this.getColumnWidth()+1;
	else				n = 1;

	do{
		count++;
		y = rec.y;
//		rec.y += this.getRowHeight()*n;
		rec.translate(0, this.getRowHeight()*n);
		if(y == rec.y)	continue;

		this.scrollRectToVisible(rec);

		rec = this.getVisibleRect();

		if(count > 10)	break;
	}while(y == rec.y);

	if(y == rec.y)
	System.out.println("err");
//	Thread.yield();
//	Thread.sleep(1);
	this.repaint();
*/
}

public void addTextSub(int s, int e)
{
	int n = removeLines(pd, root);

	if(highlight)	addHighlighter();

	if(scroll)	setCaretPosition(pd.getLength());
	else{
//			if(e != 0)
//			select(s, e);
		setCaretPosition(0);

		s -= n;
		e -= n;

		if(s < 0)	s = 0;
		if(e < 0)	e = 0;
		if(s < e)
		select(s, e);
	}
}

private int removeLines(Document doc, Element root)
{
	if(root.getElementCount() - limit-2 < 0)	return 0;

	Element fl = root.getElement(root.getElementCount() - limit-2);

	try{
		int n = fl.getEndOffset();
		doc.remove(0, n);
		return n;
	}
	catch(BadLocationException ble){
		System.out.println(ble);
	}
	return 0;
}
/*
public void paintComponent(Graphics G)
{
	Graphics2D g = (Graphics2D)G;
//	GraphicsConfiguration gc = g.getDeviceConfiguration();
//	Font f = g.getFont().deriveFont(gc.getDefaultTransform());

	Font f = new Font("MS PGothic", Font.PLAIN, 12);
	int n = f.getSize();
	double d = n*(1/1.8288);
	d = d/0.352778;///1000);

	f = f.deriveFont((float)d);
	setFont(f);
	super.paintComponent(g);
	System.out.println(""+g.getFont().getSize2D());
	System.out.println(""+f.getSize2D());
}
*/
}
