import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.io.*;
import java.util.*;
import java.awt.geom.*;


public class Laser extends Object implements Basis
{

public static final int end = 10;
public static final int store = 6;
public static final int width = 20;
public static final int range = 500;

public static Polygon model;

protected int flag;
protected Point point;
protected double radian;
//protected int range;
protected int scene;
protected Polygon p;


static
{
	model = new Polygon();
	model.addPoint(40, -width/2);
	model.addPoint(range, -width/2);
	model.addPoint(range, width/2);
	model.addPoint(40, width/2);
}

public Laser(int flag, int x, int y, double radian)//, int range)
{
	this.flag = flag;
	this.point = new Point(x, y);
	this.radian = radian;
//	this.range = range;
	scene = 0;
	p = Transform(point, radian, range, 20);
}

protected static Polygon Transform(Point p, double radian, int range, int width)
{
	AffineTransform at;
	Point2D po;
	Polygon material;

	material = new Polygon();

	at = new AffineTransform();
//	at.setToTranslation(p.getX(), p.getY());
	at.setToRotation(radian);

	for(int n=0;n<model.npoints;n++){
		po = at.transform(new Point(model.xpoints[n], model.ypoints[n]), null);
		material.addPoint((int)(po.getX()+p.getX()), (int)(po.getY()+p.getY()));
	}
	return material;
}


public int isHitCount(Polygon enemy, Point center)
{
	int n, i = 0;
	if(isHit(center))	i++;

	for(n=0;n<enemy.npoints;n++)
		if(isHit(enemy.xpoints[n], enemy.ypoints[n]))	i++;

	return i;
}

public boolean isHit(Polygon enemy, Point center)
{
	if(isHit(center))	return true;

	for(int n=0;n<enemy.npoints;n++)
		if(isHit(enemy.xpoints[n], enemy.ypoints[n]))	return true;

	return false;
}

public boolean isHit(int x, int y)
{
	if(p.contains(x, y))	return true;
	return false;
}

public boolean isHit(Point po)
{
	if(p.contains(po))		return true;
	return false;
}



public boolean Acttion(Point po, double ra)
{
	point = po;
	radian = ra;
	p = Transform(point, radian, range, 20);

	scene++;
	if(scene > end)	return true;
	return false;
}


public String getCode()
{
	return LASER+P+flag+P+point.x+P+point.y+P+radian;
}


public void paint(Graphics2D g, int offsetX, int offsetY)
{
	AffineTransform at = g.getTransform();
	int x = point.x+offsetX;
	int y = point.y+offsetY;

	g.translate(x, y);
	g.rotate(radian);

	g.setColor(new Color(0x88ff8888));
	if(scene < store)
			g.fillArc(40, -scene*2, scene*4, scene*4, 0, 360);
	else	g.fillPolygon(model);

	g.setTransform(at);
}


public int getX(){				return point.x;		}
public int getY(){				return point.y;		}
public int getScene(){			return scene;		}
public Polygon getPolygon(){	return p;			}
public String getPolygonString()
{
	String s = "";
	for(int n=0;n<p.npoints;n++)
		s += p.xpoints[n]+" "+p.ypoints[n]+" ";

	return s;
}

}
