import java.io.*;
import java.net.*;
import java.awt.*;
import java.awt.im.*;
import java.awt.image.*;
import java.awt.event.*;
import java.awt.geom.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;
import java.util.*;
import static java.awt.RenderingHints.*;

@SuppressWarnings({"unchecked", "serial"})

public class Lobby extends Begin implements Runnable, Basis
{

private static JTextAreaScroll notify;
private DefaultListModel namedlm;
private JList names;
private JTextField message, secret;
private JLabel number, sos, pc, board;
private JButton enter, exit, scroll, translation;
private JScrollPane a, b;

private TranslationDialog td;
private Thread th;
private boolean Provess;
private boolean update;



public Lobby(Socket s, DataOutputStream out, DataInputStream in, int flag, String name)
{
	super(LOBBY, DEFAULT_LOOP);

	Process = true;

	so = s;
	this.out = out;
	this.in = in;

	cmself = new ClientMember(flag, LOBBY, FIELD_LOBBY, name);
	cm[cmself.getFlag()] = cmself;

	th = new Thread(this);
}

public Lobby()
{
	super(LOBBY, DEFAULT_LOOP);
	Process = true;

	th = new Thread(this);
}

public void setPanel()
{
	namedlm = new DefaultListModel();
	names = new JList(namedlm);
	names.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
//	names.setEnabled(false);
	names.addFocusListener(new NameFocusListener(names));
	a = new JScrollPane(names);
	a.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
	a.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);

	notify = new JTextAreaScroll(new PlainDocument(), JTextAreaScroll.LOG_BASIS);
	notify.setLineWrap(true);
	notify.setEditable(false);
	notify.setTabSize(4);
	b = new JScrollPane(notify);
	b.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
	b.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);

	message = new JTextField();
	secret = new JTextField();
	number = new JLabel(NUMBER+"0");
	board = new JLabel("fW");
	sos = new JLabel(SOS+"0");
	pc = new JLabel(PC+"0");
	enter = new JButton("ENTER");
	exit = new JButton("EXIT");
	scroll = new JButton("SCR F");
	translation = new JButton("EXCITE");

	cl.setLayout(null);
	number.setBounds(10, 10, 145, 20);
	a.setBounds(10, 40, 145, 510);
	board.setBounds(165, 7, 625, 26);
	b.setBounds(165, 40, 625, 480);
	message.setBounds(165, 530, 625, 20);
	exit.setBounds(10, 562, 80, 25);
	scroll.setBounds(100, 562, 80, 25);
	translation.setBounds(190, 562, 80, 25);
	sos.setBounds(WW-180, 555, 80, 20);
	pc.setBounds(WW-180, 575, 80, 20);
	enter.setBounds(WW-80-10, 562, 80, 25);

	notify.setWidth(625);

	cl.add(number);
	cl.add(a);
	cl.add(board);
	cl.add(b);
	cl.add(message);
	cl.add(exit);
	cl.add(scroll);
//	cl.add(translation);
	cl.add(sos);
	cl.add(pc);
	cl.add(enter);

	message.addActionListener(cl);
	exit.addActionListener(cl);
	enter.addActionListener(cl);
	scroll.addActionListener(cl);
	translation.addActionListener(cl);

	cl.addMouseListener(cl);
//	names.addMouseListener(cl);
//	notify.addMouseListener(cl);
//	message.addMouseListener(cl);

	names.addKeyListener(kd);
	notify.addKeyListener(kd);
	message.addKeyListener(kd);


	JPopupMenu popMessage = new JPopupMenu("pme");
	JPopupMenu popNotify = new JPopupMenu("pno");
	JPopupMenu popNames = new JPopupMenu("pna");
	JMenuItem mi0 = new JMenuItem("cut");
	JMenuItem mi1 = new JMenuItem("copy");
	JMenuItem mi2 = new JMenuItem("copy");
	JMenuItem mi3 = new JMenuItem("copy");
	JMenuItem mi4 = new JMenuItem("paste");
	JMenuItem mi5 = new JMenuItem("homepage");

	mi0.setActionCommand("cutMessage");
	mi1.setActionCommand("copyMessage");
	mi2.setActionCommand("copyNotify");
	mi3.setActionCommand("copyNames");
	mi4.setActionCommand("pasteMessage");
	mi5.setActionCommand("homepageNotify");

	mi0.addActionListener(cl);
	mi1.addActionListener(cl);
	mi2.addActionListener(cl);
	mi3.addActionListener(cl);
	mi4.addActionListener(cl);
	mi5.addActionListener(cl);

	popMessage.add(mi0);
	popMessage.add(mi1);
	popMessage.add(mi4);
	popNotify.add(mi2);
	popNotify.add(mi5);
	popNames.add(mi3);

	message.setComponentPopupMenu(popMessage);
	notify.setComponentPopupMenu(popNotify);
	names.setComponentPopupMenu(popNames);
}



public void run()
{
	String data;
	try{
		while(Process){
			data = in.readUTF();
			if(data != null)		Process(data);
		}
		return;
	}
	catch(EOFException ex){
		setClientError(ERR_EOF);
		ex.printStackTrace();
	}
	catch(IOException ex){
		if(getScene() != EXIT)	setClientError(ERR_IO);
		Function.TestString("Lobby-run, err IO");
		ex.printStackTrace();
	}
	catch(Exception ex){
		setClientError(ERR_ABNORMALITY);
		Function.TestString("Lobby-run, err abnormality");
		ex.printStackTrace();
	}
	Function.TestString("Lobby-run, end.");
	ExitProcess();
}


public static synchronized void addText(String data)
{
	Function.LogWrite(FORTH+data+"\n");
	notify.addText(FORTH+data);
}

private void Process(String data)
{
	StringTokenizer st = new StringTokenizer(data, P);

	if(st.countTokens() < 1){
		Function.TestString("Lobby-Process, There is no value. "+data);
		return;
	}

	int n = Function.Extraction(st.nextToken());
	if(n == SIGNAL)	return;

	Function.TestString("Lobby-Process, "+data);

	switch(n){
		case SIGNAL:											break;
		case CHAT:				AnalysisChatCode(st);			break;
		case CHAT_SERVER:		AnalysisChatServerCode(st);		break;
		case CHAT_LOBBY:		AnalysisChatCode(st);			break;
		case CHAT_SERVER_LOBBY:	AnalysisChatServerCode(st);		break;
		case CHAT_NAMELESS:		AnalysisNamelessChatCode(st);	break;
		case LOGIN:				AnalysisLoginCode(st);			break;
		case LOGOUT:			AnalysisLogoutCode(st);			break;
		case LOGIN_FIELD:		AnalysisFieldLoginCode(st);		break;
		case LOGOUT_FIELD:		AnalysisFieldLogoutCode(st);	break;
		case FIELD_LABEL:		AnalysisFieldLabelCode(st);		break;
		case NOTICE_SERVER:		AnalysisNoticeLabelCode(st);		break;

		case ERR_ABNORMALITY:
		case ERR_KICK:
		case ERR_TIMEOUT:
		case ERR_NODATA:
		case ERR_SERVER:		AnalysisErrCode(n);				break;

		case ERR:
			System.out.println("integet error : "+data);
			break;
		default:
			System.out.println("no data "+data);
			break;
	}
}

public void AnalysisLoginCode(StringTokenizer st)
{
	if(st.countTokens() != 4){
		Function.TestString("Lobby-AnalysisLoginCode, The number of values is abnormal. "+st.countTokens());
		return;
	}

	try{
		int flag = Integer.parseInt(st.nextToken());
		int status = Integer.parseInt(st.nextToken());
		int area = Integer.parseInt(st.nextToken());
		String name = st.nextToken();

		cm[flag] = new ClientMember(flag, status, area, name);
		if(status == LOBBY)	addText(name+" entered a room.");
//		update = true;
		addName(cm[flag].getName(), flag);
	}
	catch(Exception ex){
		Function.TestString("Lobby-AnalysisLoginCode, The value is strange.");
		ex.printStackTrace();
	}
}

public void AnalysisFieldLoginCode(StringTokenizer st)
{
	if(st.countTokens() != 15){
		Function.TestString("Lobby-AnalysisFieldLoginCode, The number of values is abnormal. "+st.countTokens());
		return;
	}

	try{
		int flag = Integer.parseInt(st.nextToken());
		int self = Integer.parseInt(st.nextToken());
		int type = Integer.parseInt(st.nextToken());
		int belong = Integer.parseInt(st.nextToken());
		double x = Double.parseDouble(st.nextToken());
		double y = Double.parseDouble(st.nextToken());
		double radian = Double.parseDouble(st.nextToken());
		double speed = Double.parseDouble(st.nextToken());
		boolean exit = Boolean.parseBoolean(st.nextToken());
		int hp = Integer.parseInt(st.nextToken());
		int atc = Integer.parseInt(st.nextToken());
		int def = Integer.parseInt(st.nextToken());
		int spd = Integer.parseInt(st.nextToken());
		int way = Integer.parseInt(st.nextToken());
		int area = Integer.parseInt(st.nextToken());

		cm[flag].setStatus(FIELD);
		cm[flag].setArea(area);
		clearName(flag, cm[flag].getName());

		if(flag != cmself.getFlag()){
			switch(area){
				case FIELD_0:
					addText(cm[flag].getName()+" went to the battlefield  of confused fight.");
					return;
				case FIELD_1:
					addText(cm[flag].getName()+" went to the battlefield  of war.");
					return;
				default:
					Function.TestString("Lobby-AnalysisFieldLoginCode, ");
					return;
			}
		}

		FieldMember fm = new FieldMember(cmself.getName(), true, 
				flag, belong, hp, atc, def, spd, way, x, y, radian, speed, exit);

		ns = new Field(fm);
		ExitProcess();
	}
	catch(Exception ex){
		Function.TestString("Lobby-AnalysisFieldLoginCode, The value is strange.");
		ex.printStackTrace();
	}
}

public void AnalysisLogoutCode(StringTokenizer st)
{
	if(st.countTokens() < 2){
		Function.TestString("Lobby-AnalysisLogoutCode, The number of values is abnormal. "+st.countTokens());
		return;
	}

	try{
		int flag = Integer.parseInt(st.nextToken());
		int status = Integer.parseInt(st.nextToken());
		Function.TestString("Lobby-AnalysisLogoutCode, a.");

		if(cm[flag] == null)	return;
		if(status == LOBBY)	addText(cm[flag].getName()+" leaves a room.");

		String name = cm[flag].getName();
		cm[flag] = null;
		if(status == LOBBY){
//			update = true;
			clearName(flag, name);
		}
	}
	catch(Exception ex){
		Function.TestString("Lobby-AnalysisLogoutCode, The value is strange.");
		ex.printStackTrace();
	}
}

public void AnalysisFieldLogoutCode(StringTokenizer st)
{
	if(st.countTokens() != 1){
		Function.TestString("Lobby-AnalysisLoginCode, The number of values is abnormal. "+st.countTokens());
		return;
	}

	try{
		int flag = Integer.parseInt(st.nextToken());
		if(cm[flag] == null)	return;

		cm[flag].setStatus(LOBBY);
		cm[flag].setArea(FIELD_NULL);
		addText(cm[flag].getName()+" came back to the lobby.");

		addName(cm[flag].getName(), flag);
	}
	catch(Exception ex){
		Function.TestString("Lobby-AnalysisLoginCode, The value is strange.");
		ex.printStackTrace();
	}
}

public void AnalysisFieldLabelCode(StringTokenizer st)
{
	if(st.countTokens() != 2){
		Function.TestString("Lobby-AnalysisLoginCode, The number of values is abnormal. "+st.countTokens());
		return;
	}

	try{
		int sos = Integer.parseInt(st.nextToken());
		int pc = Integer.parseInt(st.nextToken());

		setFieldLabel(sos, pc);
	}
	catch(Exception ex){
		Function.TestString("Lobby-AnalysisLoginCode, The value is strange.");
		ex.printStackTrace();
	}
}

public void AnalysisNoticeLabelCode(StringTokenizer st)
{
	if(st.countTokens() != 1){
		Function.TestString("Lobby-AnalysisLoginCode, The number of values is abnormal. "+st.countTokens());
		return;
	}

	try{
		String data = st.nextToken();

		setNoticeLabel(data);
		Function.TestString("Lobby-AnalysisNoticeLabelCode, "+data);
	}
	catch(Exception ex){
		Function.TestString("Lobby-AnalysisLoginCode, The value is strange.");
		ex.printStackTrace();
	}

}

private void AnalysisChatCode(StringTokenizer st)
{
	if(st.countTokens() < 2)	return;

	int flag = Function.Extraction(st.nextToken());
	String data = st.nextToken();

	if(cm[flag] == null)	addText(NO_NAME+" : "+data);
	else					addText(cm[flag].getName()+" : "+data);
}

private void AnalysisNamelessChatCode(StringTokenizer st)
{
	if(st.countTokens() != 1)	return;
	addText(NUSIGUED_NAME+" : "+st.nextToken());
}

private void AnalysisChatServerCode(StringTokenizer st)
{
	if(st.countTokens() != 1)	return;
	addText(SERVER_NAME+" : "+st.nextToken());
}

private void AnalysisErrCode(int err)
{
	setServerError(err);
	ns = this;
	ExitProcess();
}



public void InitProcess()
{
	StartProcess();
	setPanel();
	setName();
	th.start();

	paint();
	repaint();
}

public void setName()
{
	addName(cmself.getName(), cmself.getFlag());

	for(int n=0;n<MAX_MEMBER;n++){
		if(cm[n] == null)	continue;
		if(cm[n].getFlag() == cmself.getFlag())	continue;

		if(cm[n].getStatus() == LOBBY)	addName(cm[n].getName(), cm[n].getFlag());
	}
}

public void EndProcess()
{
	Function.TestString("Lobby-EndProcess, s.");
	cl.removeAll();
	repaint();
	Join();
	Function.TestString("Lobby-EndProcess, e.");
}

public void LoopProcess()
{
	Send(SIGNAL+"");

/*	if(update){
		RenewalNames();
		repaint();
		update = false;
	}
*/
}

public void LastProcess()
{
	if(Scene.getServerError() == ERR_NOMAL)
		Close(ERR_CLIENT+"");
}



public void ActionPerformed(ActionEvent e)
{
	if(e.getSource() == message){
		if(textCeck(message.getText())){
			message.setText("");
			return;
		}
		Send(CHAT_LOBBY+P+cmself.getFlag()+P+message.getText());
		message.setText("");
	}
	else if(e.getSource() == enter)		FieldRelation();
	else if(e.getSource() == exit){
		ns = new Entrance();
		ExitProcess();
		Close(null);
	}
	else if(e.getSource() == scroll){
		notify.changeScroll();
		setScroll();
	}
	else if(e.getSource() == translation){
		if(td == null)			td = new TranslationDialog(f);
		else if(!td.getExist()){
			td = null;
			td = new TranslationDialog(f);
		}
	}

	String action = e.getActionCommand();
	if(action.equals("cutMessage"))			message.cut();
	else if(action.equals("copyMessage"))	message.copy();
	else if(action.equals("copyNotify"))	notify.copy();
	else if(action.equals("copyNames"))		getNames();
	else if(action.equals("pasteMessage"))	message.paste();
	else if(action.equals("homepageNotify"))Function.Browser(notify.getSelectedText());
}

public void setScroll()
{
//	if(notify.getScroll())	scroll.setText("SCROLL OFF");
//	else					scroll.setText("SCROLL ON");
	if(notify.getScroll())	scroll.setText("SCR F");
	else					scroll.setText("SCR N");
}

public void getNames()
{
	if(names.getSelectedIndex() == -1)	return;

	secret.setText((String)names.getSelectedValue());
	secret.selectAll();
	secret.copy();
}

private boolean textCeck(String data)
{
	if(message.getText().length() == 0);
	else if(data.indexOf("/") == 0);
	else	return false;

	StringTokenizer st = new StringTokenizer(data, PT);
	if(st.countTokens() < 1)	return true;
	String d = st.nextToken();

	if(d.equals("/font"))			setFont(st, data);
	else if(d.equals("/highlight"))	Function.setHighlight(st, data, notify);
	else if(d.equals("/turn"))		Function.setTurn(st, notify);
	else if(d.equals("/delete"))	notify.setText("");
	else if(d.equals("/save"))		Function.saveText(notify);
	else if(d.equals("/www"))		Function.BrowserIsExecuted(st, data);
	else if(d.equals("/log"))		setLog(st);
	else if(d.equals("/scroll")){
		Function.setScroll(st, notify);
		setScroll();
	}
	else if(d.equals("/AA")){
		if(st.countTokens() != 0)	return true;
		AreaDialog();
	}
	else if(d.equals("/repaint")){
		RenewalNames();
		repaint();
	}
	else if(d.equals("/-")){
		if(st.countTokens() < 1)	return true;
		Send(CHAT_NAMELESS+P+LOBBY+P+message.getText().substring("/-".length()+1));
	}
	else if(d.equals("/input")){
		if(st.countTokens() < 1)	return true;
		Send(PRESERVE_LOBBY+P+cmself.getFlag()+P+message.getText().substring("/input".length()+1));		
	}
	else if(d.equals("/show"))	Show(st);

	return true;
}

private void setFont(StringTokenizer st, String data)
{
	Font font, fo = Function.setFont(st, data, notify.getFont());
	if(fo == null){
		String sty = "";
		font = notify.getFont();

		switch(font.getStyle()){
			case Font.PLAIN:			sty += "plain";			break;
			case Font.BOLD:				sty += "bold";			break;
			case Font.ITALIC:			sty += "italic";			break;
			case Font.BOLD+Font.ITALIC:	sty += "bold and italic";	break;
		}

		addText("It changed to size "+font.getSize()+sty+" of font "+font.getName()+".");
	}
	else{
		if(	fo.getName().equals("MS PGothic") && 
			fo.getStyle() == Font.PLAIN &&
			( fo.getSize() == 12 || fo.getSize() == 16))	notify.setTurn(false);

		if(	fo.getName().equals("Dialog") &&
			fo.getStyle() == Font.PLAIN &&
			fo.getSize() == 12)								notify.setTurn(true);

		notify.setFont(fo);
	}
}

public void Show(StringTokenizer st)
{
	if(st.countTokens() == 1){
		String d = st.nextToken();
		if(d.equals("board"))	addText(board.getText());
	}
}

public void AreaDialog()
{
	AreaDialog ad = new AreaDialog(f, notify.getFont(), CLIENT);

	if(ad.getSelect() != AreaDialog.SELECT_OK)	return;

	String data[] = ad.getStrings();

	for(int n=0;n<data.length;n++)
		Send(CHAT_LOBBY+P+cmself.getFlag()+P+data[n]);
}

public void setLog(StringTokenizer st)
{
	int n = Function.setLog(st);

	switch(n){
		case ERR:												break;
		case -2:	notify.setLimit();							break;
		case -3:	addText("log limit "+notify.getLimit());	break;
		case -4:	notify.setLimit(Integer.MAX_VALUE);			break;
		default:	if(0 <= n && n <= Integer.MAX_VALUE)		notify.setLimit(n);
	}
}

public void MousePressed(MouseEvent e)
{
//	if(!names.contains(e.getX(), e.getY())){
		names.clearSelection();
		Function.Focus(cl);
//		names.setFocusable(false);
//	}

}

public void MouseReleased(MouseEvent e)
{

}

public void MouseMoved(MouseEvent e)
{

}

public void KeyEnterEvent()
{
	Focus(message);
}


public void paint()
{
	g.setColor(new Color(0xeeeeee));
	g.fillRect(0, 0, WW, WH);
}



public void FieldRelation()
{
	FieldLoginDialog fld = new FieldLoginDialog(new JFrame());

	if(fld.getSelect() != FieldLoginDialog.SELECT_OK)
		return;
	Function.TestString("Lobby-FieldRelation, stop");

//	return;

	Send(LOGIN_FIELD+P+cmself.getFlag()+P+fld.getArea()+P+fld.getBelong()+P+
									fld.getAtc()+P+fld.getDef()+P+fld.getSpd());
}



public void RenewalNames()
{
	int i = 0;
	namedlm.clear();

	for(int n=0;n<cm.length;n++){
		if(cm[n] != null && cm[n].getStatus() == LOBBY){
			addNameSub(cm[n].getName(), cm[n].getFlag());
			i++;
		}
	}
	number.setText(NUMBER+i);
}

public synchronized void setNumber()
{
	int i = 0;
	for(int n=0;n<cm.length;n++){
		if(cm[n] != null && cm[n].getStatus() == LOBBY)	i++;
	}
	number.setText(NUMBER+i);
}

public synchronized void addName(String name, int flag)
{
	addNameSub(name, flag);
	setNumber();
}

public synchronized void addNameSub(String name, int flag)
{
	if(cm[flag].getStatus() == LOBBY)
		namedlm.addElement(ListName(flag, name));
}

public synchronized void clearName(int flag, String name)
{
	namedlm.removeElement(ListName(flag, name));
	setNumber();
}

public synchronized String ListName(int flag, String name)
{
	String f;
	if(flag < 10)	f = "0"+flag;
	else			f = flag+"";

	return f+" : "+name;
}


public synchronized void setFieldLabel(int vsos, int vpc)
{
	sos.setText(SOS+vsos);
	pc.setText(PC+vpc);
}

public synchronized void setNoticeLabel(String data)
{
	board.setText(data);
}


public void Join()
{
	try{
		ExitProcess();
		th.join();
	}
	catch(Exception ex){
		ex.printStackTrace();
	}
}

public static int getObjectCount(Object obj[])
{
	int n, count = 0;

	for(n=0;n<obj.length;n++)
		if(obj[n] != null)	count++;

	return count;
}

protected void ExitProcess()
{
	Process = false;
	super.ExitProcess();
}


public void repaint()
{
	g.setColor(new Color(0xeeeeee));
	g.fillRect(0, 0, WW, WH);

	super.repaint();
}


}

