import java.io.*;
import java.net.*;
import java.awt.*;
import java.awt.im.*;
import java.awt.image.*;
import java.awt.event.*;
import java.awt.geom.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;
import java.util.*;
import static java.awt.RenderingHints.*;


public class Management extends Object implements Runnable, KeyListener, Basis
{

public static final int NODATA				= 7100;
public static final int OPEN				= 7101;
public static final int CLOSE				= 7102;
public static final int CLOSE_PREPARATION	= 7103;

private static Management ma;
private static JFrame f;
private static Server se;
private static Thread th;

private boolean Process;

private static JTextAreaScroll notify;
private DefaultListModel namedlm;
private JList names;
private JTextField message, secret;
private JLabel number, sos, pc, board;
private JButton open, kick, area, translation;
private JPopupMenu popMessage, popNotify, popNames;

private TranslationDialog td;
private ServerMember sm[];

private boolean update;
private int status;
private String preserve;
private ServerSocket ss;

private static BufferedWriter bw;


public Management(JFrame jf, Server s)
{
	ma = this;
	f = jf;
	se = s;
	th = null;
	td = null;

	Process = true;
	update = false;
	status = NODATA;
	preserve = "";
	ServerMember.getManagement(this);
	sm = new ServerMember[MAX_MEMBER];

	setPanel();
	addTextData("start up  tdos "+VERSION_STR);

	SocketOpen();
}

public void setPanel()
{
	JScrollPane a, b;

	namedlm = new DefaultListModel();
	names = new JList(namedlm);
	names.addFocusListener(new NameFocusListener(names));
	a = new JScrollPane(names);
	a.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
	a.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);

	notify = new JTextAreaScroll(new PlainDocument(), Integer.MAX_VALUE);
	notify.setLineWrap(true);
	notify.setEditable(false);
	notify.setTabSize(4);
	b = new JScrollPane(notify);
	b.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
	b.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);

	message = new JTextField();
	secret = new JTextField();
	number = new JLabel(NUMBER+"0", JLabel.LEFT);
	board = new JLabel("fW");
	sos = new JLabel(SOS+"0");
	pc = new JLabel(PC+"0");
//	font = new JLabel(NUMBER+"0", JLabel.LEFT);
	open = new JButton("OPEN");
	kick = new JButton("KICK");
	area = new JButton("AREA");
	translation = new JButton("EXCITE");

	se.setLayout(null);
	number.setBounds(10, 10, 145, 20);
	a.setBounds(10, 40, 145, 510);
	board.setBounds(165, 7, 625, 26);
	b.setBounds(165, 40, 625, 480);
	message.setBounds(165, 530, 625, 20);
	open.setBounds(10, 562, 80, 25);
	kick.setBounds(100, 562, 80, 25);
	area.setBounds(190, 562, 80, 25);
	translation.setBounds(280, 562, 80, 25);
	sos.setBounds(WW-90, 555, 80, 20);
	pc.setBounds(WW-90, 575, 80, 20);

	notify.setWidth(625);

	se.add(number);
	se.add(a);
	se.add(board);
	se.add(b);
	se.add(message);
	se.add(open);
	se.add(kick);
	se.add(area);
//	se.add(translation);
	se.add(sos);
	se.add(pc);

	message.addActionListener(se);
	open.addActionListener(se);
	kick.addActionListener(se);
	area.addActionListener(se);
	translation.addActionListener(se);


	popMessage = new JPopupMenu("pme");
	popNotify = new JPopupMenu("pno");
	popNames = new JPopupMenu("pna");
	JMenuItem mi0 = new JMenuItem("cut");
	JMenuItem mi1 = new JMenuItem("copy");
	JMenuItem mi2 = new JMenuItem("copy");
	JMenuItem mi3 = new JMenuItem("copy");
	JMenuItem mi4 = new JMenuItem("paste");
	JMenuItem mi5 = new JMenuItem("homepage");

	mi0.setActionCommand("cutMessage");
	mi1.setActionCommand("copyMessage");
	mi2.setActionCommand("copyNotify");
	mi3.setActionCommand("copyNames");
	mi4.setActionCommand("pasteMessage");
	mi5.setActionCommand("homepageNotify");

	mi0.addActionListener(se);
	mi1.addActionListener(se);
	mi2.addActionListener(se);
	mi3.addActionListener(se);
	mi4.addActionListener(se);
	mi5.addActionListener(se);

	popMessage.add(mi0);
	popMessage.add(mi1);
	popMessage.add(mi4);
	popNotify.add(mi2);
	popNotify.add(mi5);
	popNames.add(mi3);

	message.setComponentPopupMenu(popMessage);
	notify.setComponentPopupMenu(popNotify);
	names.setComponentPopupMenu(popNames);


	se.addKeyListener(this);
	notify.addKeyListener(this);
	names.addKeyListener(this);
	message.addKeyListener(this);
	se.addMouseListener(se);
//	notify.addMouseListener(se);
//	names.addMouseListener(se);
//	message.addMouseListener(se);
}


public void MainLoop()
{
	long time;
	int slp, n;

	while(Process){
		time = System.currentTimeMillis();

		Send(ALL, ALL, 0, FIELD_NULL, SIGNAL+"");

		for(n=0;n<sm.length;n++){
			if(sm[n] == null)				continue;
			if(sm[n].getStatus() != FIELD)	continue;
			sm[n].move();

			sm[n].laser();
		}

		CheckClose();

		if(update){
			RenewalNames();
			update = false;
		}

		time = System.currentTimeMillis() - time;
		slp = 100 - (int)time;
		try{
			if(slp < 0)	Function.TestString("Management-MainLoop, Time slice. "+slp);
			else		Thread.sleep(slp);
		}
		catch(Exception ex){
			ex.printStackTrace();
		}
	}
	Function.TestString("Management-MainLoop, end");
}

public void run()
{
	try{
		int n;
		Socket s;
		ServerMember se;

		addTextData("wait : "+PORT);

		status = OPEN;
		ss = new ServerSocket(PORT);

		while(Process){
			s = ss.accept();

			addTextData("connection : "+s.getInetAddress());

			n = getEmptinessObjcet(sm);
			if(n == ERR){
				addTextData("member limit over : "+s.getInetAddress());
				s.close();
				s = null;
				continue;
			}

			se = new ServerMember(s, n);
			if(se.getError() != ERR_NOMAL){
				addTextData("error : "+se.getShowErrorCode());
				se.Close(se.getErrorCode());
				se.Join();
				se = null;
				continue;
			}
			sm[n] = se;
			ma.addName(sm[n].getName(), sm[n].getFlag(), sm[n].getStatus());
			ma.Send(LOBBY, ALL, 0, FIELD_NULL, NOTICE_SERVER+P+ma.getBoard());
//			UpdateName();
			addTextData("login : "+sm[n].getDatas());
		}
	}
	catch(SocketException ex){
		if(status != CLOSE_PREPARATION)	ex.printStackTrace();
	}
	catch(Exception ex){
		ex.printStackTrace();
	}

	AllClose();
	SubSocketClose();
	addTextData("stop");
	status = CLOSE;
	th = null;
}

public void AllClose()
{
	for(int n=0;n<sm.length;n++)
		if(sm[n] != null)	sm[n].setError(ERR_SERVER);

	CheckClose();
}

public void CheckClose()
{
	synchronized (sm){
		for(int n=0;n<sm.length;n++){
			if(sm[n] == null)	continue;
			if(sm[n].getError() != ERR_NOMAL){
				addTextData("logout : "+sm[n].getShowErrorCode());

				if(sm[n].getError() != ERR_CLOSE)
					sm[n].Close(sm[n].getErrorCode());

				addTextData("close : "+sm[n].getDatas());
				Send(ALL, ALL, n, FIELD_NULL, LOGOUT+P+sm[n].getFlag()+P+sm[n].getStatus());
				while(sm[n].getError() != ERR_CLOSE)	sm[n].setError(ERR_CLOSE);

				int status = sm[n].getStatus();
				String name = sm[n].getName();
				sm[n] = null;
				clearName(n, status, name);
				ma.SendLabelData();
//				UpdateName();
			}
		}
	}
}


public void ActionPerformed(ActionEvent e)
{
	if(e.getSource() == message){
		if(textCeck(message.getText())){
			message.setText("");
			return;
		}
		message.setText(ServerMember.setCommntData(message.getText(), -2));
		Send(ALL, ALL, 0, FIELD_NULL, CHAT_SERVER+P+message.getText());
		addText(SERVER_NAME+" : "+message.getText());
		message.setText("");
	}
	else if(e.getSource() == open){
		if(th == null)		SocketOpen();
		else if(ss != null)	SocketClose();
	}
	else if(e.getSource() == kick){
//		Kicks(names.getSelectedIndices());
		Kicks(names.getSelectedValues());
		names.clearSelection();
	}
	else if(e.getSource() == area)	AreaDialog();
	else if(e.getSource() == translation){
		if(td == null)			td = new TranslationDialog(f);
		else if(!td.getExist()){
			td = null;
			td = new TranslationDialog(f);
		}
	}

	String action = e.getActionCommand();
	if(action.equals("cutMessage"))				message.cut();
	else if(action.equals("copyMessage"))		message.copy();
	else if(action.equals("copyNotify"))		notify.copy();
	else if(action.equals("copyNames"))			getNames();
	else if(action.equals("pasteMessage"))		message.paste();
	else if(action.equals("homepageNotify"))	Function.Browser(notify.getSelectedText());
}

private boolean textCeck(String data)
{
	if(message.getText().length() == 0)		return true;
	else if(data.indexOf("/") == 0);
	else	return false;

	StringTokenizer st = new StringTokenizer(data, PT);
	if(st.countTokens() < 1)	return true;
	String d = st.nextToken();

	if(d.equals("/font"))			setFont(st, data);
	else if(d.equals("/scroll"))	Function.setScroll(st, notify);
	else if(d.equals("/highlight"))	Function.setHighlight(st, data, notify);
	else if(d.equals("/turn"))		Function.setTurn(st, notify);
	else if(d.equals("/delete"))	notify.setText("");
	else if(d.equals("/save"))		Function.saveText(notify);
	else if(d.equals("/www"))		Function.BrowserIsExecuted(st, data);
	else if(d.equals("/log"))		setLog(st);
	else if(d.equals("/AA")){
		if(st.countTokens() != 0)	return true;
		AreaDialog();
	}
	else if(d.equals("/repaint")){
		RenewalNames();
		se.repaint();
	}
	else if(d.equals("/-")){
		if(st.countTokens() < 1)	return true;
		NamelessCommentSend(ALL, 0, 0, message.getText().substring("/-".length()+1));
	}
	else if(d.equals("/f")){
		if(st.countTokens() < 1)	return true;
		Send(FIELD, ALL, 0, ALL, CHAT_SERVER+P+message.getText().substring("/f".length()+1));
		addText(SERVER_NAME+" : "+message.getText().substring("/f".length()+1));
	}
	else if(d.equals("/l")){
		if(st.countTokens() < 1)	return true;
		Send(LOBBY, ALL, 0, FIELD_NULL, CHAT_SERVER+P+message.getText().substring("/l".length()+1));
		addText(SERVER_NAME+" : "+message.getText().substring("/l".length()+1));
	}
	else if(d.equals("/board")){
		if(st.countTokens() < 1)	return true;
		Send(LOBBY, ALL, 0, FIELD_NULL, NOTICE_SERVER+P+message.getText().substring("/board".length()+1));
		board.setText(message.getText().substring("/board".length()+1));
	}
	else if(d.equals("/translation")){
		if(td == null)			td = new TranslationDialog(f);
		else if(!td.getExist()){
			td = null;
			td = new TranslationDialog(f);
		}
	}
	else if(d.equals("/input")){
		if(st.countTokens() < 1)	return true;
		preserve = ServerMember.setPreserve(message.getText().substring("/board".length()+1), -2);
		Send(ALL, ALL, 0, FIELD_NULL, CHAT_SERVER+P+"y Data is preserved. z");
		addText(SERVER_NAME+" : "+"y Data is preserved. z");
	}
	else if(d.equals("/show"))	Show(st);

	return true;
}

private void setFont(StringTokenizer st, String data)
{
	Font font, fo = Function.setFont(st, data, notify.getFont());
	if(fo == null){
		String sty = "";
		font = notify.getFont();

		switch(font.getStyle()){
			case Font.PLAIN:			sty += "plain";			break;
			case Font.BOLD:				sty += "bold";			break;
			case Font.ITALIC:			sty += "italic";			break;
			case Font.BOLD+Font.ITALIC:	sty += "bold and italic";	break;
		}

		addText("It changed to size "+font.getSize()+sty+" of font "+font.getName()+".");
	}
	else{
		if(	fo.getName().equals("MS PGothic") && 
			fo.getStyle() == Font.PLAIN &&
			( fo.getSize() == 12 || fo.getSize() == 16))	notify.setTurn(false);

		if(	fo.getName().equals("Dialog") &&
			fo.getStyle() == Font.PLAIN &&
			fo.getSize() == 12)								notify.setTurn(true);

		notify.setFont(fo);
	}
}

public void Show(StringTokenizer st)
{
	if(st.countTokens() == 1){
		String d = st.nextToken();
		if(d.equals("board"))	addText(board.getText());
	}
}

public void keyPressed(KeyEvent e)
{
	switch(e.getKeyCode()) {
		case KeyEvent.VK_ENTER:		Focus(message);	break;
	}
}

public void keyReleased(KeyEvent e)
{

}

public void keyTyped(KeyEvent e)
{

}


public void AreaDialog()
{
	AreaDialog ad = new AreaDialog(f, notify.getFont(), SERVER);

	if(ad.getSelect() != AreaDialog.SELECT_OK)	return;

	String data[] = ad.getStrings();
	int where = ad.getWhere();

	for(int n=0;n<data.length;n++){
		data[n] = ServerMember.setCommntData(data[n], -2);
		Send(where, ALL, 0, ALL, CHAT_SERVER+P+data[n]);
		addText(SERVER_NAME+" : "+data[n]);
	}
}

public void Kicks(int i[])
{
	for(int n=0;n<i.length;n++){
		if(sm[i[n]] != null)	sm[i[n]].setError(ERR_KICK);
	}
}

public void Kicks(Object obj[])
{
	int n, i;
	String data;
	for(n=0;n<obj.length;n++){
		try{
			data = (String)obj[n];
			data = data.substring(data.indexOf("0")==1? 2:1, data.indexOf(" "));
			i = Integer.parseInt(data);
			if(sm[i] != null)	sm[i].setError(ERR_KICK);
		}
		catch(Exception ex){
			ex.printStackTrace();
		}
	}
}

public void SocketOpen()
{
	ServerMember.StartProcess();
	th = new Thread(this);
	th.start();
	open.setText("CLOSE");
}

public void SocketClose()
{
	try{
		status = CLOSE_PREPARATION;
		ss.close();
		ss = null;
		th.join();
		th = null;

		ServerMember.ExitProcess();
		open.setText("OPEN");
	}
	catch(Exception ex){
		Function.TestString("Management-stop, close or join");
		ex.printStackTrace();
	}
}

public void SubSocketClose()
{
	try{
		if(status != OPEN || ss == null || th == null)	return;
//		if(status != OPEN && ss == null && th == null)	return;

		ss.close();
		ss = null;

		ServerMember.ExitProcess();
		open.setText("OPEN");
	}
	catch(Exception ex){
		Function.TestString("Management-stop, close or join");	
		ex.printStackTrace();
	}
}

public void getNames()
{
	if(names.getSelectedIndex() == -1)	return;

	Object obj[] = names.getSelectedValues();
	String name, data;

	data = (String)obj[0];
	name = data.substring(data.indexOf(" : ")+3, data.length());
	for(int n=1;n<obj.length;n++){
		data = (String)obj[n];
		data = data.substring(data.indexOf(" : ")+3, data.length());
		name = name+" "+data;
	}
	secret.setText(name);
	secret.selectAll();
	secret.copy();
}

public void setLog(StringTokenizer st)
{
	int n = Function.setLog(st);

	switch(n){
		case ERR:												break;
		case -2:	notify.setLimit();							break;
		case -3:	addText("log limit "+notify.getLimit());	break;
		case -4:	notify.setLimit(Integer.MAX_VALUE);			break;
		default:	if(0 <= n && n <= Integer.MAX_VALUE)		notify.setLimit(n);
	}
}


public void MousePressed(MouseEvent e)
{
//	if(!names.contains(e.getX(), e.getY())){
		names.clearSelection();
		Function.Focus(se);
//		names.setFocusable(false);
//	}
}

public void MouseReleased(MouseEvent e)
{

}



public void CommentSend(int command, int style, int flag, String data)
{
	if(flag < 0 || MAX_MEMBER < flag)	return;

	addText(sm[flag].getName()+" :l: "+data);
	Send(command, style, flag, FIELD_NULL, CHAT+P+flag+P+data);
}

public void FieldCommentSend(int command, int style, int flag, int area, String data)
{
	if(flag < 0 || MAX_MEMBER <= flag)	return;

	addText(sm[flag].getName()+" :f: "+data);
	Send(command, style, flag, area, CHAT_FIELD+P+flag+P+style+P+data);
}

public void NamelessCommentSend(int command, int area, int flag, String data)
{
	if(command == LOBBY)		addText(NUSIGUED_NAME+" :l:"+flag+": "+data);
	else if(command == FIELD)	addText(NUSIGUED_NAME+" :f:"+flag+": "+data);
	else if(command == ALL)		addText(NUSIGUED_NAME+" : "+data);

	Send(command, ALL, 0, area, CHAT_NAMELESS+P+data);
}

public synchronized void Send(int command, int style, int self, int etc, String data)
{
	for(int n=0;n<sm.length;n++){
		if(sm[n] == null)	continue;
		if(sm[n].getError() != ERR_NOMAL)	continue;
		if(sm[n].getStatus() == LOBBY);
		else if(sm[n].getStatus() == FIELD);
		else	continue;

		if(command == ALL)			sm[n].Send(data);
		else if(command == LOBBY && sm[n].getStatus() == LOBBY){
			if(style == ALL)		sm[n].Send(data);
		}
		else if(command == FIELD && sm[n].getStatus() == FIELD && sm[n].getArea() == etc){
			if(style == ALL)		sm[n].Send(data);
			else if(style == GROUP && self == sm[n].getBelong())
									sm[n].Send(data);
		}
		else if(command == FIELD && sm[n].getStatus() == FIELD && etc == ALL)
			sm[n].Send(data);
	}
}



public void MemberData(ServerMember se)
{
	ServerMember.setStop(true);
	int i = 0;
	String data[] = new String[getObjectCount(sm)];
	
 	for(int n=0;n<MAX_MEMBER;n++){
		if(sm[n] == null)	continue;

//		data[i++] = LOGIN+P+sm[n].getFlag()+P+sm[n].getStatus()+P+sm[n].getArea()+P+sm[n].getName();
		data[i++] = sm[n].getEnterCode();
	}
	se.Send(data);
	ServerMember.setStop(false);
}

public void FieldMemberData(ServerMember se, int area)
{
	ServerMember.setStop(true);
	int i = 0;
	String data[] = new String[getFieldCount(sm, area)];
	
 	for(int n=0;n<MAX_MEMBER;n++){
		if(sm[n] == null)	continue;
		
		if(sm[n].getStatus() == FIELD && sm[n].getArea() == area)
			data[i++]	= sm[n].getCode()+P+sm[n].getArea();
	}
	se.Send(data);
	ServerMember.setStop(false);
}

public void SendLabelData()
{
	int sos = 0;
	int pc = 0;

	for(int n=0;n<MAX_MEMBER;n++){
		if(sm[n] == null)	continue;
		if(sm[n].getBelong() == Base.SOS_PARTY)		sos++;
		else if(sm[n].getBelong() == Base.PC_STUDYS)	pc++;
	}

	ma.Send(LOBBY, ALL, 0, FIELD_NULL, FIELD_LABEL+P+sos+P+pc);
	setFieldLabel(sos, pc);
}

public synchronized void setFieldLabel(int vsos, int vpc)
{
	sos.setText(SOS+vsos);
	pc.setText(PC+vpc);
}



public void ServerMemberDamage(int flag, int damage)
{
	sm[flag].Damage(damage);
}

public int getServerMemberHp(int flag)
{
	return sm[flag].getHp();
}

public int getServerMemberDef(int flag)
{
	return sm[flag].getDef();
}

public int getServerMemberAtc(int flag)
{
	return sm[flag].getAtc();
}

public int getServerMemberSpd(int flag)
{
	return sm[flag].getSpd();
}

public String getServerMemberPreserve(int flag)
{
	if(!(0 <= flag  && flag < sm.length))	return this.preserve;
	return sm[flag].getPreserve();
}




public static synchronized void addText(String data)
{
	Function.LogWrite(FORTH+data+"\n");
	notify.addText(FORTH+data);
}

public static synchronized void addTextData(String data)
{
	Calendar cal1 = Calendar.getInstance(TimeZone.getTimeZone("Asia/Tokyo"));

	String date;
	date = "["+getStringData(cal1.get(Calendar.MONTH) + 1);
	date += "/"+getStringData(cal1.get(Calendar.DATE));
	date += " "+getStringData(cal1.get(Calendar.HOUR_OF_DAY));
	date += ":"+getStringData(cal1.get(Calendar.MINUTE));
	date += ":"+getStringData(cal1.get(Calendar.SECOND))+"]";
	addText(date+"   "+data);
}

public static String getStringData(int data)
{
	if(data < 10)	return "0"+data;
	return data+"";
}

public void RenewalNames()
{
	Function.TestString("Management-RenewalNames, test");
	number.setText(NUMBER+getObjectCount(sm));
	namedlm.clear();

	for(int n=0;n<sm.length;n++){
		if(sm[n] != null)	addNameSub(sm[n].getName(), n, sm[n].getStatus());
	}
}

public synchronized void addName(String name, int flag, int status)
{
	addNameSub(name, flag, status);
	number.setText(NUMBER+getObjectCount(sm));
}

public synchronized void addNameSub(String name, int flag, int status)
{
	namedlm.addElement(ListName(flag, status, name));
}

public synchronized void clearName(int flag, int status, String name)
{
	namedlm.removeElement(ListName(flag, status, name));
	number.setText(NUMBER+getObjectCount(sm));
}

public synchronized String ListName(int flag, int status, String name)
{
	String f;
	if(flag < 10)	f = "0"+flag;
	else			f = flag+"";

	switch(status){
		case LOBBY:	f = "L"+f;	break;
		case FIELD:	f = "F"+f;	break;
		default:	f = "X"+f;	break;
	}
	return f+" : "+name;
}

public void UpdateName()
{
	update = true;
}

public String getBoard()
{
	return board.getText();
}


public int Extraction(String data)
{
	try{
		return Integer.parseInt(data);
	}
	catch(Exception ex){
		return ERR;
	}
}

public int getEmptinessObjcet(Object obj[])
{
	for(int n=0;n<obj.length;n++){
		if(obj[n] == null)	return n;
	}
	return ERR;
}

public static int getObjectCount(Object obj[])
{
	int n, count = 0;

	for(n=0;n<obj.length;n++){
		if(obj[n] != null)	count++;
	}

	return count;
}

public static int getFieldCount(ServerMember obj[], int area)
{
	int n, count = 0;

	for(n=0;n<obj.length;n++){
		if(obj[n] != null){
			if(obj[n].getStatus() == FIELD && obj[n].getArea() == area)
				count++;
		}
	}

	return count;
}

public int getObjectIndex(ServerMember obj[], int flag)
{
	for(int n=0;n<obj.length;n++){
		if(obj[n] != null && obj[n].getFlag() == flag)	return n;
	}
	return ERR;
}

public void Focus(Component c)
{
	FocusEvent event = new FocusEvent(c, FocusEvent.FOCUS_GAINED);
	Toolkit.getDefaultToolkit().getSystemEventQueue().postEvent(event);
}

public static void Exit()
{
	ma.Send(ALL, ALL, 0, FIELD_NULL, ERR_SERVER+"");

	ma.ExitProcess();
	if(se != null)	se.ExitProcess();
	ServerMember.ExitProcess();

	Function.LogStreamClose();
	Function.TestString("Management-Exit, exit.");
	System.exit(0);
}

public void ExitProcess()
{
	Process = false;
}

}
