import java.io.*;
import java.net.*;
import java.awt.*;
import java.awt.im.*;
import java.awt.image.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.lang.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.imageio.*;
import java.util.*;
import static java.awt.RenderingHints.*;

abstract class Scene extends Object implements Basis
{
/*
public static final int UNDECIDED = 1000;
public static final int BEGIN = 1001;
public static final int EXIT = 1002;
public static final int ENTRANCE = 1011;
public static final int LOBBY = 1012;
public static final int FIELD = 1013;
*/
public static final int BASIS_TIME = 100;


public static boolean test;
private static int scene;
private static boolean error;
private static int ServerError;
private static int ClientError;
protected static Scene sc;
protected static Scene ns;
protected static JFrame f;
protected static Client cl;
protected static Thread th;
protected static KeyData kd;

protected static BufferedImage OffScreen;
protected static Graphics2D g;

protected static Socket so;
protected static DataOutputStream out;
protected static DataInputStream in;

protected static ClientMember cmself;
protected static ClientMember cm[];

protected boolean Process;
protected int LoopTime;

private static BufferedWriter bw;


static
{
	test = TEST;
	scene = BEGIN;
	ServerError = ERR_NOMAL;
	ClientError = ERR_NOMAL;
	error = false;

	so = null;
	out = null;
	in = null;

	cmself = null;
	cm = new ClientMember[MAX_MEMBER];
}

public Scene(int scene, int time)
{
	sc = this;
	this.scene = scene;
	Process = true;

	if(setLoopTime(time))	LoopTime = time;
	else					LoopTime = BASIS_TIME;
}

public static void setInit()
{
	OffScreen = new BufferedImage(WW, WH, BufferedImage.TYPE_INT_BGR);
	g = OffScreen.createGraphics();
	g.setRenderingHint(KEY_ANTIALIASING, VALUE_ANTIALIAS_ON);
}

public static void setClient(JFrame jf, Client c, Thread t)
{
	f = jf;
	cl = c;
	th = t;
}

public static void setKeyData(KeyData key)
{
	kd = key;
}

protected boolean setLoopTime(int val)
{
	if(0 < val){
		LoopTime = val;
		return true;
	}
	return false;
}

public static void setClientError(int err)
{
	ClientError = err;
	error = true;
}

public static boolean getError()
{
	return error;
}

public static int getClientError()
{
	return ClientError;
}

protected static void setServerError(int err)
{
	ServerError = err;
	error = true;
}

public static int getServerError()
{
	return ServerError;
}

protected void ExitProcess()
{
	Process = false;
}

protected void StartProcess()
{
	Process = true;
}


protected void repaint()
{
	cl.repaint();
}

public static Image getOffScreen()
{
	return OffScreen;
}

public static int getScene()
{
	return scene;
}



public Scene MainLoop()
{
	long time;
	int slp;

	ns = null;
	InitProcess();

	while(Process){
		time = System.currentTimeMillis();

		LoopProcess();

		time = System.currentTimeMillis() - time;
		slp = LoopTime - (int)time;
		try{
			if(slp < 0)	Function.TestString("Scene-MainLoop, Time slice. "+slp);
			else		Thread.sleep(slp);
		}
		catch(Exception ex){
			ex.printStackTrace();
		}
	}
	EndProcess();
	return ns;
}


abstract protected void InitProcess();
abstract protected void LoopProcess();
abstract protected void EndProcess();
abstract protected void LastProcess();

abstract protected void KeyEnterEvent();

abstract public void ActionPerformed(ActionEvent e);
abstract public void MousePressed(MouseEvent e);
abstract public void MouseReleased(MouseEvent e);
abstract public void MouseMoved(MouseEvent e);



public void Send(String data)
{
	try{
		if(MAX_CHARACTER < data.length())
			data = 	data.substring(0, MAX_CHARACTER);

		out.writeUTF(data);
		out.flush();
	}
	catch(Exception ex){
		ExitProcess();
		ex.printStackTrace();
	}
}

public void Close(String data)
{
	if(so.isClosed())	return;
	try{
		scene = EXIT;
		if(data != null)	Send(data);
		so.close();
	}
	catch(Exception ex){
		ex.printStackTrace();
	}
}



public BufferedImage getImage(String name)
{
	try{
		return ImageIO.read(getClass().getResource(name));
	}
	catch(IOException e){
		Function.TestString("Scene-getImage, read error. "+name);
		e.printStackTrace();
	}
	catch(Exception e){
		Function.TestString("Scene-getImage, no data. "+name);
		e.printStackTrace();
	}
	return null;
}

public BufferedImage getImageFile(String name)
{
	try{
		return ImageIO.read(new File(name));
	}
	catch(IOException e){
		Function.TestString("Scene-getImage, read error. "+name);
		e.printStackTrace();
	}
	catch(Exception e){
		Function.TestString("Scene-getImage, no data. "+name);
		e.printStackTrace();
	}
	return null;
}

public void Focus(Component c)
{
	FocusEvent event = new FocusEvent(c, FocusEvent.FOCUS_GAINED);
	Toolkit.getDefaultToolkit().getSystemEventQueue().postEvent(event);
}

}
