import java.io.*;
import java.net.*;
import java.awt.*;
import java.awt.im.*;
import java.awt.image.*;
import java.awt.event.*;
import java.awt.geom.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;
import static java.awt.RenderingHints.*;


public class ServerMember extends Unit implements Runnable, Basis
{
/*
public static final int CONNECTION	= 3051;
public static final int ENTER		= 3052;
public static final int EXIT		= 3053;
public static final int BATTLEFIELD	= 3054;
*/

private static boolean Process;
private static boolean stop;
private static Management ma;


private int status;					//ꏊ
private int error;
private int flag;
private int area;
private String name;
private String preserve;
private String addErrorData;

private Socket so;
private DataOutputStream out;
private DataInputStream in;

private Thread th;



static
{
	Process = false;
	stop = false;
}

public static void getManagement(Management m)
{
	ma = m;
}

public static void StartProcess()
{
	Process = true;
}

public static void ExitProcess()
{
	Process = false;
}



public ServerMember(Socket s, int flag)
{
	super(false, flag, Base.OTHER, ERR, ERR, ERR, ERR, ERR, ERR, false);

	so = s;
	status = BEGIN;
	area = FIELD_LOBBY;
	error = ERR_NOMAL;
	this.flag = flag;
	name = "no_name";
	preserve = "";
	addErrorData = "";

	try{
		so.setTcpNoDelay(true);
		so.setSoLinger(false, LINGER);
		so.setSoTimeout(SERVER_SIGNAL_TIME_OUT);

		out = new DataOutputStream(new BufferedOutputStream(so.getOutputStream()));
		in  = new DataInputStream(new BufferedInputStream(so.getInputStream()));
//		out = new DataOutputStream(so.getOutputStream());
//		in = new DataInputStream(so.getInputStream());

		error = AnalysisLoginCode(in.readUTF(), flag);
	}
	catch(Exception ex){
		error = ERR_ABNORMALITY;
		ex.printStackTrace();
	}
	
	th = new Thread(this);
	th.start();
}

public int AnalysisLoginCode(String data, int flag)
{
	if(data == null)	return ERR_LOGIN;

	StringTokenizer st = new StringTokenizer(data, P);
	Function.TestString("ServerMemver-AnalysisLoginCode, "+data);

	if(st.countTokens() != 3){
		if(st.countTokens() != 5){
			Function.TestString("ServerMemver-AnalysisLoginCode, The number of values is abnormal. "+st.countTokens());
			addErrorData = "size "+st.countTokens()+" "+data;
			return ERR_LOGIN;
		}

		try{
			int ver = Integer.parseInt(st.nextToken());
			int atc = Integer.parseInt(st.nextToken());
			int def = Integer.parseInt(st.nextToken());
			int spd = Integer.parseInt(st.nextToken());
			String name = st.nextToken();
			addErrorData = "name "+name+",  ver "+ver;
			return ERR_VERSION;
		}
		catch(Exception ex){
			Function.TestString("ServerMemver-AnalysisLoginCode, The value is strange.");
			ex.printStackTrace();
		}

		Function.TestString("ServerMemver-AnalysisLoginCode, The number of values is abnormal. "+st.countTokens());
		addErrorData = "size "+st.countTokens()+" "+data;
		return ERR_LOGIN;
	}

	int login, ver;
	login = ver = -1;

	try{
		login = Integer.parseInt(st.nextToken());
		ver = Integer.parseInt(st.nextToken());
		this.name = st.nextToken();

		if(0 < login && login < 12){
			addErrorData = "name "+name+",  ver "+ver;
			return ERR_VERSION;
		}
		if(login != LOGIN){
			addErrorData = "data "+login+",  name "+name+",  ver "+ver;
			return ERR_LOGIN;
		}
		else if(ver != VERSION){
			addErrorData = "name "+name+",  ver "+ver;
			return ERR_VERSION;
		}

		status = LOBBY;

		Send(LOGIN+P+flag+P+name);
//		ma.Send(ALL, ALL, flag, FIELD_NULL, LOGIN+P+flag+P+LOBBY+P+FIELD_LOBBY+P+name);
		ma.Send(ALL, ALL, flag, FIELD_NULL, getEnterCode());
		ma.MemberData(this);
		ma.SendLabelData();
		return ERR_NOMAL;
	}
	catch(Exception ex){
		Function.TestString("ServerMemver-AnalysisLoginCode, The value is strange.");
		ex.printStackTrace();
	}
	addErrorData = "data "+login+",  name "+name+",  ver "+ver;
	return ERR_LOGIN;
}



public void run()
{
	String data;
	Function.TestString("ServerMemver-run, start.");
	try{
		while(Process){
			if(error != ERR_NOMAL)	break;

			data = in.readUTF();

	
			if(data != null)	Process(data);
		}
	}
	catch(SocketTimeoutException ex){	
		error = ERR_TIMEOUT;
		ex.printStackTrace();
	}
	catch(EOFException ex){
		error = ERR_EOF;
		ex.printStackTrace();			
	}
	catch(IOException ex){
		error = ERR_IO;
		ex.printStackTrace();
	}
	catch(Exception ex){
		error = ERR_ABNORMALITY;
		ex.printStackTrace();
	}
	Function.TestString("ServerMemver-run, end.");
}

public void Send(String data)
{
	try{
		while(stop)	Thread.yield();

		if(MAX_CHARACTER < data.length())
			data = 	data.substring(0, MAX_CHARACTER);

		out.writeUTF(data);
		out.flush();
	}
	catch(Exception ex){
		error = ERR_ABNORMALITY;
		ex.printStackTrace();
	}
}

public void Send(String data[])
{
	try{
		for(int n=0;n<data.length;n++){
			out.writeUTF(data[n]);
			out.flush();
		}
	}
	catch(Exception ex){
		error = ERR_ABNORMALITY;
		ex.printStackTrace();
	}
}

public void Close(String data)
{
	try{
		if(data != null)	Send(data);
		so.close();
	}
	catch(Exception ex){
		ex.printStackTrace();
	}
	error = ERR_CLOSE;
}


public void Process(String data)
{
	StringTokenizer st = new StringTokenizer(data, P);
	if(st.countTokens() < 1){
		Function.TestString("ServerMemver-Process, There is no value. "+data);
		return;
	}

	int n = Extraction(st.nextToken());
	if(n == SIGNAL)	return;

//	TestString("ServerMemver-Process, "+data);

	switch(n){
		case SIGNAL:												break;
		case CHAT:				AnalysisChatCode(st, ALL);			break;
		case CHAT_LOBBY:		AnalysisChatCode(st, LOBBY);		break;
		case CHAT_FIELD:		AnalysisFieldChatCode(st, FIELD);	break;
		case CHAT_NAMELESS:		AnalysisNamelessChatCode(st);		break;
		case PRESERVE_LOBBY:	AnalysisPreserveCode(st, LOBBY);	break;
		case PRESERVE_FIELD:	AnalysisPreserveCode(st, FIELD);	break;
		case LOGIN_FIELD:		AnalysisFieldLoginCode(st);			break;
		case LOGOUT_FIELD:		AnalysisFieldLogoutCode(st);		break;
		case SPEED:				AnalysisSpeedChange(st);			break;
		case ROLL:				AnalysisRoll(st);					break;
		case LASER:				AnalysisLaser(st);					break;
		case DAMAGE:			AnalysisDamage(st);					break;

		case ERR_CLIENT:	setError(ERR_CLIENT);				break;
		case ERR:
			Function.TestString("ServerMemver-Process, The value is strange. "+data);
			break;
		default:
			Function.TestString("ServerMemver-Process, Unconfirmed value. "+data);
			break;
	}	
}

public void AnalysisChatCode(StringTokenizer st, int command)
{
	if(st.countTokens() < 2){
		Function.TestString("ServerMemver-AnalysisChatCode, The number of values is abnormal. "+st.countTokens());
		return;
	}

	try{
		int flag = Integer.parseInt(st.nextToken());
		String data = st.nextToken();
		data = setCommnt(data);

		ma.CommentSend(command, ALL, flag, data);
	}
	catch(Exception ex){
		Function.TestString("ServerMemver-AnalysisChatCode, The value is strange.");
		ex.printStackTrace();
		return;
	}
}

public void AnalysisFieldChatCode(StringTokenizer st, int command)
{
	if(st.countTokens() < 3){
		Function.TestString("ServerMemver-AnalysisChatCode, The number of values is abnormal. "+st.countTokens());
		return;
	}

	try{
		int flag = Integer.parseInt(st.nextToken());
		int who = Integer.parseInt(st.nextToken());
		String data = st.nextToken();
		data = setCommnt(data);

		switch(who){
			case ALL:	break;
			case GROUP:	break;
			default:	return;
		} 

		ma.FieldCommentSend(command, who, flag, getArea(), data);
	}
	catch(Exception ex){
		Function.TestString("ServerMemver-AnalysisChatCode, The value is strange.");
		ex.printStackTrace();
		return;
	}
}

public void AnalysisPreserveCode(StringTokenizer st, int command)
{
	if(st.countTokens() < 2){
		Function.TestString("ServerMemver-AnalysisChatCode, The number of values is abnormal. "+st.countTokens());
		return;
	}

	try{
		int flag = Integer.parseInt(st.nextToken());
		String data = st.nextToken();
		data = setCommnt(data);

		preserve = setPreserve(data, flag);
		data = "y Data is preserved. z";

		if(command == LOBBY)		ma.CommentSend(command, ALL, flag, data);
		else if(command == FIELD)	ma.FieldCommentSend(command, ALL, flag, getArea(), data);
	}
	catch(Exception ex){
		Function.TestString("ServerMemver-AnalysisChatCode, The value is strange.");
		ex.printStackTrace();
		return;
	}
}

public void AnalysisFieldLoginCode(StringTokenizer st)
{
	if(st.countTokens() != 6){
		Function.TestString("ServerMemver-AnalysisFieldLoginCode, The number of values is abnormal. "+st.countTokens());
		return;
	}

	try{
		int flag = Integer.parseInt(st.nextToken());
		int area = Integer.parseInt(st.nextToken());
		int belong = Integer.parseInt(st.nextToken());
		int atc = Integer.parseInt(st.nextToken());
		int def = Integer.parseInt(st.nextToken());
		int spd = Integer.parseInt(st.nextToken());

		if(this.flag != flag)	return;
		if(atc+def+spd > 100)	return;
		switch(belong){
			case Base.SOS_PARTY:
			case Base.PC_STUDYS:
			case Base.WATCH:
			case Base.OTHER:	break;
			default:			return;
		}
		switch(area){
			case FIELD_0:
			case FIELD_1:	break;
			default:		return;
		}

		this.area = area;
		Random random = new Random(new Date().getTime());
		init(false, flag, belong, Unit.HP_MAX, atc, def, spd, 0, random.nextInt(500), random.nextInt(500), 
													Base.getRadian(0.0), Base.getSpeed(spd), true);

		ma.Send(ALL, ALL, flag, FIELD_NULL, getCode()+P+area);
		ma.FieldMemberData(this, area);
		ma.clearName(flag, status, name);
		status = FIELD;
		ma.addName(name, flag, status);
		ma.SendLabelData();

		switch(area){
			case FIELD_0:	ma.addText(name+" went to the battlefield  of confused fight.");	break;
			case FIELD_1:	ma.addText(name+" went to the battlefield  of war.");				break;
		}	
	}
	catch(Exception ex){
		Function.TestString("ServerMemver-AnalysisFieldLoginCode, The value is strange.");
		ex.printStackTrace();
		return;
	}
}

public void AnalysisFieldLogoutCode(StringTokenizer st)
{
	if(st.countTokens() != 1){
		Function.TestString("ServerMemver-AnalysisFieldLoginCode, The number of values is abnormal. "+st.countTokens());
		return;
	}

	try{
		int flag = Integer.parseInt(st.nextToken());

		init(false, flag, Base.OTHER, ERR, ERR, ERR, ERR, ERR, ERR, ERR, 0.0, ERR, false);

		ma.Send(ALL, ALL, flag, FIELD_NULL, LOGOUT_FIELD+P+flag);
		ma.clearName(flag, status, name);
		status = LOBBY;
		ma.addName(name, flag, status);
		this.area = FIELD_NULL;
		ma.SendLabelData();

		ma.Send(LOBBY, ALL, 0, FIELD_NULL, NOTICE_SERVER+P+ma.getBoard());
		ma.addText(name+" came back to the lobby.");
	}
	catch(Exception ex){
		Function.TestString("ServerMemver-AnalysisFieldLoginCode, The value is strange.");
		ex.printStackTrace();
		return;
	}
}

public void AnalysisNamelessChatCode(StringTokenizer st)
{
	if(st.countTokens() < 2){
		Function.TestString("ServerMemver-AnalysisChatCode, The number of values is abnormal. "+st.countTokens());
		return;
	}

	try{
		int command = Integer.parseInt(st.nextToken());
		String data = st.nextToken();
		data = setCommnt(data);

		ma.NamelessCommentSend(command, getArea(), flag, data);
	}
	catch(Exception ex){
		Function.TestString("ServerMemver-AnalysisChatCode, The value is strange.");
		ex.printStackTrace();
		return;
	}
}



public void AnalysisSpeedChange(StringTokenizer st)
{
	if(st.countTokens() != 2){
		Function.TestString("ServerMemver-AnalysisFieldLoginCode, The number of values is abnormal. "+st.countTokens());
		return;
	}

	try{
		if(status != FIELD)	return;

		int flag = Integer.parseInt(st.nextToken());
		int data = Integer.parseInt(st.nextToken());

		if(flag != getFlag())	return;
		switch(data){
			case UP:		speedChange(1);		break;
			case DOWN:		speedChange(-1);	break;
			case STOP:		speedChange(0);		break;
			default:		return;
		}
		ma.Send(FIELD, ALL, flag, getArea(), SPEED+P+flag+P+way);
	}
	catch(Exception ex){
		Function.TestString("ServerMemver-AnalysisFieldLoginCode, The value is strange.");
		ex.printStackTrace();
		return;
	}
}

public void AnalysisRoll(StringTokenizer st)
{
	if(st.countTokens() != 2){
		Function.TestString("ServerMemver-AnalysisFieldLoginCode, The number of values is abnormal. "+st.countTokens());
		return;
	}

	try{
		if(status != FIELD)	return;

		int flag = Integer.parseInt(st.nextToken());
		int data = Integer.parseInt(st.nextToken());

		if(flag != getFlag())	return;
		switch(data){
			case ROLL_LEFT:		roll(getRadian(-2.5));	break;
			case ROLL_RIGHT:	roll(getRadian(2.5));		break;
			default:		return;
		}
		ma.Send(FIELD, ALL, flag, getArea(), ROLL+P+flag+P+radian);
	}
	catch(Exception ex){
		ex.printStackTrace();
	}
}

public void AnalysisLaser(StringTokenizer st)
{
	if(status != FIELD)	return;
	if(st.countTokens() != 1){
		Function.TestString("ServerMemver-AnalysisFieldLoginCode, The number of values is abnormal. "+st.countTokens());
		return;
	}

	try{
		int flag = Integer.parseInt(st.nextToken());

		if(flag != getFlag())	return;
		if(laser != null)		return;

		laser = new Laser(flag, getX(), getY(), radian);
		ma.Send(FIELD, ALL, flag, getArea(), getLaserCode());
	}
	catch(Exception ex){
		ex.printStackTrace();
	}
}

public void AnalysisDamage(StringTokenizer st)
{
	if(status != FIELD)	return;
	if(st.countTokens() != 3){
		Function.TestString("ServerMemver-AnalysisFieldLoginCode, The number of values is abnormal. "+st.countTokens());
		return;
	}

	try{
		int flag = Integer.parseInt(st.nextToken());
		int enemy = Integer.parseInt(st.nextToken());
		int type = Integer.parseInt(st.nextToken());

		if(flag != getFlag())	return;

		int d = (int)((ma.getServerMemberAtc(enemy)+30)*3-(getDef()-30)*1);
		if(d < 0)	d = 0;

		switch(type){
			case LASER:	d = (int)(d/3 + 10);	break;
		}

//		ma.ServerMemberDamage(enemy, d);
		Damage(d);
		if(hp < 0)	exit = false;
		ma.Send(FIELD, ALL, enemy, getArea(), HP+P+self+P+hp);
	}
	catch(Exception ex){
		ex.printStackTrace();
	}
}



public String setCommnt(String data)
{
	data = setCommntData(data, flag);
	return data;
}

public static String setCommntData(String data, int flag)
{
	if(data.indexOf("y") != -1)		data = data.replaceAll("y", "y.");

	if(data.indexOf("!omikuji") != -1)	data = data.replaceFirst("!omikuji", "y"+Function.getOmikuji()+"z");
	if(data.indexOf("!number") != -1)	data = data.replaceFirst("!number", "y"+(int)(Math.random()*1000)+"z");
	if(data.indexOf("!dama") != -1)		data = data.replaceFirst("!dama", "y"+(int)(Math.random()*1000)+"z");
	if(data.indexOf("!kao") != -1)		data = data.replaceFirst("!kao", "y"+Function.getKaomozi()+"z");
	if(data.indexOf("!out") != -1){
		String d = ma.getServerMemberPreserve(flag);
		data = data.replaceFirst("!out", "y"+d+"z");
	}

	if(data.indexOf("#") == 0)			data = "y"+Function.getTrip(data)+"z";
	return data;
}




public static void setStop(boolean val){	stop = val;			}
public void setError(int err){				error = err;		}
public static String setPreserve(String data, int flag)
{
	if(data.indexOf("y") != -1)		data = data.replaceAll("y", "y.");
	if(data.indexOf("!omikuji") != -1)	data = data.replaceFirst("!omikuji", "y"+Function.getOmikuji()+"z");
	if(data.indexOf("!number") != -1)	data = data.replaceFirst("!number", "y"+(int)(Math.random()*1000)+"z");
	if(data.indexOf("!dama") != -1)		data = data.replaceFirst("!dama", "y"+(int)(Math.random()*1000)+"z");
	if(data.indexOf("!kao") != -1)		data = data.replaceFirst("!kao", "y"+Function.getKaomozi()+"z");

	if(MAX_CHARACTER < data.length())
		data = 	data.substring(0, MAX_CHARACTER);

	return data;
}

public int getStatus(){			return status;			}
public int getError(){			return error;			}
public int getFlag(){			return flag;			}
public int getArea(){			return area;			}
public String getName(){		return name;			}
public String getPreserve(){	return preserve;		}

public String getDatas()
{
	return "#"+flag+"  "+name+so.getInetAddress();
}

public String getErrorCode()
{
	switch(error){
		case ERR_NOMAL:
		case ERR_CLOSE:			break;
		case ERR_CLIENT:		return null;
		case ERR_VERSION:		return ERR_VERSION+P+VERSION_STR;
		case ERR_LOGIN:
		case ERR_ABNORMALITY:
		case ERR_KICK:
		case ERR_TIMEOUT:
		case ERR_SERVER:

		case ERR_EOF:
		case ERR_IO:			return error+"";
	}
	return ERR_NODATA+"";
}

public String getShowErrorCode()
{
	switch(error){
		case ERR_NOMAL:			return "nomal";
		case ERR_CLOSE:			return "close";
		case ERR_CLIENT:		return "client(end)";					//NCAgI
		case ERR_VERSION:		return "version : "+addErrorData;
		case ERR_LOGIN:			return "login : "+addErrorData;
		case ERR_ABNORMALITY:	return "abnormality";
		case ERR_KICK:			return "kick";
		case ERR_TIMEOUT:		return "signal time out";
		case ERR_SERVER:		return "server";
		case ERR_EOF:			return "eof(exit)";
		case ERR_IO:			return "io";
	}
	return "no data";
}

public String getCode()
{
	return LOGIN_FIELD+P+super.getCode();
//	return flag+P+self+P+type+P+belong+P+dpoint.getX()+P+dpoint.getY()+P+radian+P+speed+P+exit;
//	return super.getCode()+P+hp+P+atc+P+def+P+spd+P+way;
}

public String getEnterCode()
{
	return LOGIN+P+getFlag()+P+getStatus()+P+getArea()+P+getName();
}

public void Join()
{
	try{
		error = ERR_JOIN;
		th.join();
	}
	catch(Exception ex){
		ex.printStackTrace();
	}
}

public int Extraction(String data)
{
	try{
		return Integer.parseInt(data);
	}
	catch(Exception ex){
		ex.printStackTrace();
		return ERR;
	}
}

}
