import java.awt.*;
import java.awt.event.*;
//import java.awt.font.TextHitInfo;
//import java.util.ArrayList;
//import javax.swing.text.*;


public class TransformModeFocusListener implements FocusListener
{

public static final int IM_NONE        = 0;	/** ϊ[hw萔FwȂ */
public static final int IM_HIRAGANA    = 1;	/** ϊ[hw萔FЂ炪 */
public static final int IM_HALFKANA    = 2;	/** ϊ[hw萔FpJi */
public static final int IM_FULLASCII   = 3;	/** ϊ[hw萔FSpp */
public static final int IM_OFF         = 4;	/** ϊ[hw萔Fړ */

protected Component com;
protected KeyData kd;
protected int type;
protected boolean old;
protected boolean focus;

/**
*	addFocusListener(new TransformModeFocusListener(com, type));
**/

public TransformModeFocusListener(Component com, KeyData kd, int type)
{
	this.com = com;
	this.kd = kd;
	this.type = type;
	old = true;
	focus = false;
}

public void focusLost(FocusEvent event)
{
	focusLostHandler();
}

public void focusGained(FocusEvent event)
{
	focusGainedHandler();
}



private void focusGainedHandler()
{
	focus = true;

	if(type != IM_NONE){
		Character.Subset[] subsets = null;
		old = com.getInputContext().isCompositionEnabled();

		switch(type){
			case IM_HIRAGANA :
				subsets = new Character.Subset[] {java.awt.im.InputSubset.KANJI};
				break;
			case IM_HALFKANA :
				subsets = new Character.Subset[] {java.awt.im.InputSubset.HALFWIDTH_KATAKANA};
				break;
			case IM_FULLASCII :
				subsets = new Character.Subset[] {java.awt.im.InputSubset.FULLWIDTH_LATIN};
				break;
			case IM_OFF:
				break;
			default :
				subsets = null;
		}
		com.getInputContext().setCharacterSubsets(subsets);
	}
}

private void focusLostHandler()
{
	focus = false;
	kd.AllReleased();

	if(type != IM_NONE){
		com.getInputContext().setCompositionEnabled(true);
		if(!old)	com.getInputContext().setCharacterSubsets(null);
	}
}



public boolean setType(int type)
{
	if(!focus){
		this.type = type;
		return true;
	}
	return false;
}

public int getType()
{
	return type;
}


}


/*
private void focusGainedHandler()
{
	if(type != IM_NONE){
		Character.Subset[] subsets = null;
		switch(type){
			case IM_HIRAGANA :
				subsets = new Character.Subset[] {java.awt.im.InputSubset.KANJI};
				break;
			case IM_HALFKANA :
				subsets = new Character.Subset[] {java.awt.im.InputSubset.HALFWIDTH_KATAKANA};
				break;
			case IM_FULLASCII :
				subsets = new Character.Subset[] {java.awt.im.InputSubset.FULLWIDTH_LATIN};
				break;
			default :
				subsets = null;
		}
		com.getInputContext().setCharacterSubsets(subsets);
	}
}

private void focusLostHandler()
{
	if(type != IM_NONE){
		com.getInputContext().setCharacterSubsets(null);
	}
}
*/
