import java.io.*;
import java.net.*;
import java.awt.*;
import java.awt.im.*;
import java.awt.image.*;
import java.awt.event.*;
import java.awt.geom.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;
import java.util.*;
import static java.awt.RenderingHints.*;


public class TranslationDialog extends JDialog implements ActionListener, WindowListener, Basis
{

public static final int TDW = 400;
public static final int TDH = 500;

private JComboBox cb1, cb2;
private JTextArea t, ta;
private JButton ok;

private boolean exist;


public static void main(String[] arge)
{
	new TranslationDialog(new JFrame());
}

public TranslationDialog(JFrame f)
{
	super(f, "EXCITE", false);
	exist = true;

	JPanel p = new JPanel();
	p.setPreferredSize(new Dimension(TDW, TDH));
	JPanel pp = new JPanel();
	JPanel pb = new JPanel();

	cb1 = new JComboBox();
	cb2 = new JComboBox();
	cb1.setEditable(false);
	cb2.setEditable(false);
	cb1.addItem("{");
	cb1.addItem("p");
//	cb1.addItem("");
//	cb1.addItem("؍");
	cb2.addItem("{");
	cb2.addItem("p");
//	cb2.addItem("");
//	cb2.addItem("؍");
	cb1.setSelectedIndex(0);
	cb2.setSelectedIndex(1);
	cb1.addActionListener(this);
	cb2.addActionListener(this);

	t = new JTextArea();
	JScrollPane a = new JScrollPane(t);
	a.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED);
	a.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);

	ta = new JTextArea();
	ta.setEditable(false);
	JScrollPane b = new JScrollPane(ta);
	b.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED);
	b.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);

	ok = new JButton("|");


	ok.addActionListener(this);

	p.setLayout(new GridLayout(2, 1));
	p.add(a);
	p.add(b);

	pp.setLayout(new FlowLayout());
	JPanel pcb = new JPanel(new FlowLayout());
	pcb.add(new JLabel("|O"));
	pcb.add(cb1);
	pcb.add(new JLabel("|"));
	pcb.add(cb2);
	pp.add(pcb);
	pp.add(ok);

	pb.setLayout(new BorderLayout());
	pb.add("North", pp);
	pb.add("Center", p);

	add(pb);

	JPopupMenu popMessage = new JPopupMenu("pme");
	JPopupMenu popNotify = new JPopupMenu("pno");
	JMenuItem mi0 = new JMenuItem("cut");
	JMenuItem mi1 = new JMenuItem("copy");
	JMenuItem mi2 = new JMenuItem("copy");
	JMenuItem mi3 = new JMenuItem("paste");
	mi0.setActionCommand("cutMessage");
	mi1.setActionCommand("copyMessage");
	mi2.setActionCommand("copyNotify");
	mi3.setActionCommand("pasteMessage");
	mi0.addActionListener(this);
	mi1.addActionListener(this);
	mi2.addActionListener(this);
	mi3.addActionListener(this);
	popMessage.add(mi0);
	popMessage.add(mi1);
	popMessage.add(mi3);
	popNotify.add(mi2);
	t.setComponentPopupMenu(popMessage);
	ta.setComponentPopupMenu(popNotify);


	this.addWindowListener(this);

	Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
	setLocation((d.width-TDW)/2, (d.height-TDH)/2);
	pack();
	setVisible(true);
}

public void actionPerformed(ActionEvent e)
{
	if(e.getSource() == ok){
		String url = SelectionURL();

		if(url != null)	setText(url+"before="+t.getText());
	}
	else if(e.getSource() == cb1 || e.getSource() == cb2)
		ok.setEnabled(SelectionButton());

	String action = e.getActionCommand();
	if(action.equals("cutMessage"))			t.cut();
	else if(action.equals("copyMessage"))	t.copy();
	else if(action.equals("copyNotify"))	ta.copy();
	else if(action.equals("pasteMessage"))	t.paste();
}

public String SelectionURL()
{
	if(((String)cb1.getSelectedItem()).equals("{")){
		if(((String)cb2.getSelectedItem()).equals("p"))
			return "http://www.excite.co.jp/world/english/?wb_lp=JAEN&";
		else if(((String)cb2.getSelectedItem()).equals(""))
			return "http://www.excite.co.jp/world/chinese/?wb_lp=JACH&";
		else if(((String)cb2.getSelectedItem()).equals("؍"))
			return "http://www.excite.co.jp/world/korean/?wb_lp=JAKO&";
	}
	else if(((String)cb1.getSelectedItem()).equals("p")){
		if(((String)cb2.getSelectedItem()).equals("{"))
			return "http://www.excite.co.jp/world/english/?wb_lp=ENJA&";
	}
	else if(((String)cb1.getSelectedItem()).equals("")){
		if(((String)cb2.getSelectedItem()).equals("{"))
			return "http://www.excite.co.jp/world/chinese/?wb_lp=CHJA&";
	}
	else if(((String)cb2.getSelectedItem()).equals("؍")){
		if(((String)cb2.getSelectedItem()).equals("{"))
			return "http://www.excite.co.jp/world/korean/?wb_lp=KOJA&";
	}

	return null;
}

public boolean SelectionButton()
{
	if(((String)cb1.getSelectedItem()).equals("{")){
		if(((String)cb2.getSelectedItem()).equals("p"))
			return true;
		else if(((String)cb2.getSelectedItem()).equals(""))
			return true;
		else if(((String)cb2.getSelectedItem()).equals("؍"))
			return true;
	}
	else if(((String)cb1.getSelectedItem()).equals("p")){
		if(((String)cb2.getSelectedItem()).equals("{"))
			return true;
	}
	else if(((String)cb1.getSelectedItem()).equals("")){
		if(((String)cb2.getSelectedItem()).equals("{"))
			return true;
	}
	else if(((String)cb1.getSelectedItem()).equals("؍")){
		if(((String)cb2.getSelectedItem()).equals("{"))
			return true;
	}

	return false;
}

public void setText(String text)
{
	int n, m;
	String data;

	ta.setText("҂...");

	data = getData(text);
	if(data == null){
		ta.setText("error");
		return;
	}

	m = data.indexOf("</textarea>");
	n = data.indexOf("<textarea", m);
	n += "<textarea cols=36 rows=15 name=\"after\" wrap=\"virtual\" style=\"width:320px;\">".length();
	m = data.indexOf("</textarea>", n);

	if(n != -1 && n < m)		ta.setText(data.substring(n, m));
}

public String getData(String data)
{
	try {
		// CGI\URLIuWFNg
		URL cgiURL = new URL(data);
		// ڑ
		URLConnection uc = cgiURL.openConnection();
//		uc.setDoOutput(true);
//		uc.setUseCaches(false);

		// CGI̓ǂݍݗpXg[J
		BufferedReader br =
			new BufferedReader(
				new InputStreamReader(uc.getInputStream()));
		// CGȈo͂ǂݍŃR\[ʂɕ\
		String line = "";
		data = "";
		while ((line = br.readLine()) != null) {
			data += line+"\n";
		}
		// Xg[
		br.close();
		return data;
	}
	catch (MalformedURLException e) {
		e.printStackTrace();
	} catch (IOException e) {
		e.printStackTrace();
	}
	return null;
}

public boolean getExist(){	return exist;	}



public void windowOpened(WindowEvent e)
{

}

public void windowClosing(WindowEvent e)
{
	exist = false;
}

public void windowClosed(WindowEvent e)
{
	exist = false;
}

public void windowIconified(WindowEvent e)
{

}

public void windowDeiconified(WindowEvent e)
{

}

public void windowActivated(WindowEvent e)
{

}

public void windowDeactivated(WindowEvent e)
{

}

}
