import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import javax.swing.*;
import javax.swing.event.*;
import java.io.*;
import java.util.*;


public class Unit extends Base implements Basis
{

public static final int HP_MAX			= 15000;
public static final int MAX_BEAM		= 10;
public static final int SPEED_CHANGE	= 4;
public static final double SPEED_BACK	= 0.8;

/*
protected int judge;				//		
protected int type;					//		unit or laser
protected int belong;				//		a or b
protected Point point;				//	ʒu
protected Point2D dpoint;			//	mȈʒu
protected int angle;				//	px
protected double cos;				//	ẍړ
protected double sin;				//	ÿړ
protected double spd;				//	ړ
protected int rest;					//	傫Ec葶ݎ
protected int etc;					//	c	G̕\
*/
protected int hp;
protected int atc;
protected int def;
protected int spd;
protected int way;

protected boolean oneself;

protected Polygon material;
public Laser laser;
public Beam beam[];



public Unit(boolean oneself, int flag, int belong, int atc, int def, int spd, int way, 
								double x, double y, boolean exit)
{
	super(flag, flag, UNIT, belong, x, y, 0.0, spd, exit);

	this.oneself = oneself;
	this.hp = HP_MAX;
	this.atc = atc;
	this.def = def;
	this.spd = spd;
	way = 0;

	laser = null;
	beam = new Beam[MAX_BEAM];
	material = new Polygon();
	Transform(Base.mUnit, material, radian);
}

public Unit(boolean oneself, int flag, int belong, int hp, int atc, int def, int spd, int way, 
								double x, double y, double radian, double speed, boolean exit)
{
	super(flag, flag, UNIT, belong, x, y, radian, speed, exit);

	this.oneself = oneself;
	this.hp = hp;
	this.atc = atc;
	this.def = def;
	this.spd = spd;
	this.way = way;

	laser = null;
	beam = new Beam[MAX_BEAM];
	material = new Polygon();
	Transform(Base.mUnit, material, radian);
}

public void init(boolean oneself, int flag, int belong, int hp, int atc, int def, int spd, int way, 
								double x, double y, double radian, double speed, boolean exit)
{
	super.init(flag, flag, UNIT, belong, x, y, radian, speed, exit);

	this.oneself = oneself;
	this.hp = hp;
	this.atc = atc;
	this.def = def;
	this.spd = spd;
	this.way = way;

	laser = null;
	for(int n=0;n<beam.length;n++)	beam[n] = null;
	material = new Polygon();
	Transform(Base.mUnit, material, radian);
}


public void move()
{
	if(!exit)			return;

	if(way > 0)			super.move(way);
	else if(way < 0)	super.move(way*SPEED_BACK);
	else 				return;

	check();
}

public void laser()
{
	if(!exit){
		laser = null;
		return;
	}

	if(laser != null)
		if(laser.Acttion(point, radian))	laser = null;
}

public void beam()
{
	if(!exit){
		beam = null;
		return;
	}

	for(int n=0;n<MAX_BEAM;n++){
		if(beam[n] != null)
			if(beam[n].move(4))
				beam[n] = null;
	}
}


public boolean speedChange(int data)
{
	if(data == 0){
		way = 0;
		return true;
	}

	data += way;
	if(data < -SPEED_CHANGE || SPEED_CHANGE < data)	return false;

	way = data;
	return true;
}

public void setWay(int data)
{
	if(data < -SPEED_CHANGE || SPEED_CHANGE < data)	return;
	this.way = data;
}

public void roll(double addRadian)
{
	super.roll(addRadian);
//	if(!(belong == WATCH || !oneself))
		Transform(Base.mUnit, material, radian);
}

public void setRoll(double addRadian)
{
	super.setRoll(addRadian);
//	if(!(belong == WATCH || !oneself))
		Transform(Base.mUnit, material, radian);
}



public void setMaterial(boolean is)
{
	if(is)	material.translate(point.x, point.y);
	else	material.translate(-point.x, -point.y);
}

public boolean isHit(Point2D p)
{
	if(!exit)	return false;
	if(material.contains(p.getX(), p.getY()))	return true;
	return false;
}

public Point getSP()
{
	int n, i;
	Point p = new Point(material.xpoints[0], material.ypoints[0]);

	for(n=1;n<material.npoints;n++){
		if(p.x > material.xpoints[n])	p.x = material.xpoints[n];
		if(p.y > material.ypoints[n])	p.y = material.ypoints[n];
	}
	return p;
}

public Point getEP()
{
	int n, i;
	Point p = new Point(material.xpoints[0], material.ypoints[0]);

	for(n=1;n<material.npoints;n++){
		if(p.x < material.xpoints[n])	p.x = material.xpoints[n];
		if(p.y < material.ypoints[n])	p.y = material.ypoints[n];
	}
	return p;
}
/*
public boolean isHit(Point p, Point s, Point e)
{
	if(!(s.x < p.x))	return false;
	if(!(p.x < e.x))	return false;
	if(!(s.y < p.y))	return false;
	if(!(p.y < e.y))	return false;

	return true;
}
*/

public boolean isHitLaser(Polygon p, Point enter)
{
	if(laser == null)	return false;
	return laser.isHit(p, enter);
}



public void paint(Graphics2D g, int offsetX, int offsetY, int BELONG)
{
	if(!exit)	return;

	switch(BELONG){
		case LASER:	if(laser != null)	laser.paint(g, offsetX, offsetY);	break;
	}
}



public void Damage(int damege)
{
	hp -= damege;
}

public int getHp(){				return hp;			}
public int getAtc(){			return atc;			}
public int getDef(){			return def;			}
public int getSpd(){			return spd;			}
public int getSpeed(){			return way;			}
public Polygon getMaterial(){	return material;	}
public Laser getLaser(){		return laser;		}

public String getCode()
{
//	return flag+P+self+P+type+P+belong+P+dpoint.getX()+P+dpoint.getY()+P+radian+P+speed+P+exit;
	return super.getCode()+P+hp+P+atc+P+def+P+spd+P+way;
}

public String getLaserCode()
{
	return laser.getCode();
}

}
